/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashCfgSector.h  :                                              //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CFLASHCFGSECTOR_H)
    #define  CFLASHCFGSECTOR_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

typedef  enum CFLSCSECtypSPECIES {
    CFLSCSEC_SpSECTORFLASHCFG = 0,
    CFLSCSEC_SpMAX
} CFLSCSEC_SPECIES;


/*The following definition is the version.*/
#define CFLSCSEC_OBJECT_VERSION 100

#define CFLSCSEC_STATIC_DATA_SIZE (3*SIZEOF(byte)+SIZEOF(uint32))

typedef struct CFlashCfgSector
{
    /* DtData members */
    uint32      ClassID;
    boolean     DirtyFlag;
 
    /* Static Data */
    byte        m_Sector;
    uint32      m_SectorSize;
    byte        m_Protected;
    byte        m_Content;
}CFlashCfgSector;

void    CFlashCfgSector_Init(CFlashCfgSector *new);
uint32  CFlashCfgSector_GetPayloadSize(CFlashCfgSector *pObject);
uint32  CFlashCfgSector_SizeAll(CFlashCfgSector *pObject);
boolean CFlashCfgSector_Deserialize(CFlashCfgSector *pObject, uint8 *pBuf);
boolean CFlashCfgSector_Serialize(CFlashCfgSector *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CFlashCfgSector();
#endif

#endif /* #if !defined(CFLASHCFGSECTOR_H) */


