/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CModuleDStd.h  :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CMODULEDSTD_H)
    #define   CMODULEDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

typedef  enum CMODDSTDtypSPECIES {
    CMODDSTD_SpSTANDARD = 0,
    CMODDSTD_SpHOST,
    CMODDSTD_SpHARDWARE,
    CMODDSTD_SpBOOTLOADER,
    CMODDSTD_SpBOOTRECOVERY,
    CMODDSTD_SpNIBPMODULE = 16,
    CMODDSTD_SpNIBPSAFETYALG,
    CMODDSTD_SpNIBPSTEPALG,
    CMODDSTD_SpNIBPFASTALG,
    CMODDSTD_SpNIBPNEONATSTEPALG,
    CMODDSTD_SpNIBPPOEMALG,
    CMODDSTD_SpTEMPMODULE = 32,
    CMODDSTD_SpSURETEMPALG,
    CMODDSTD_SpSPO2MODULE = 40,
    CMODDSTD_SpECGMODULE = 48,
    CMODDSTD_SpMEANS,
    CMODDSTD_SpSPIROMETRY = 56,
    CMODDSTD_SpFRONTEND = 192,
    CMODDSTD_SpPPP,
    CMODDSTD_SpSECUREDIGITALCARD,
    CMODDSTD_SpMAX
} CMODDSTD_SPECIES;

/*The following definition is the version.*/
#define CMODDSTD_OBJECT_VERSION 100

#define VERSION_SIZE        16
#define DESCRIPTION_SIZE    32

#define CMODDSTD_STATIC_DATA_SIZE (VERSION_SIZE + DESCRIPTION_SIZE)

typedef struct CModuleDStd
{
    /* DtData Members */
    uint32      ClassID;
    boolean     DirtyFlag;

    /*Static Data*/
    ansichar    m_Version[VERSION_SIZE / 2];
    ansichar    m_Description[DESCRIPTION_SIZE / 2];
}CModuleDStd;

void    CModuleDStd_Init(CModuleDStd *new, uint8 Species);
uint32  CModuleDStd_GetPayloadSize(CModuleDStd *pObject);
uint32  CModuleDStd_SizeAll(CModuleDStd *pObject);
boolean CModuleDStd_Deserialize(CModuleDStd *pObject, uint8 *pBuf);
boolean CModuleDStd_Serialize(CModuleDStd *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CModuleDStd();
#endif

#endif /* #if !defined(CMODULEDSTD_H) */


