/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CTOCDStd.h  :                                                     //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CTOCDStd_H)
    #define  CTOCDStd_H

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

/*The following definition is the version.*/
#define CTOCDSTD_OBJECT_VERSION 100

typedef  enum CTOCDSTDtypSPECIES {
    CTOCDSTD_SpSTANDARD,
    CTOCDSTD_SpFLASHSECTOR,
    CTOCDSTD_SpMAX
} CTOCDSTD_SPECIES;

#define CTOCDSTD_STATIC_DATA_SIZE (MOIB_TIME_SIZE)
#define CTOCDSTD_MAX_DATA_SIZE 64

typedef struct CTOCDStd
{
    /*DtData members*/
    uint32    ClassID;
    boolean   DirtyFlag;

    /*Static Data*/
    MOIB_TIME m_SDateTime;

    /*Dynamic Data*/
    uint32    m_Contents[CTOCDSTD_MAX_DATA_SIZE];
    uint16    m_ContentsSize;
}CTOCDStd;

void    CTOCDStd_Init(CTOCDStd *new, uint8 Species);
uint32  CTOCDStd_GetPayloadSize( CTOCDStd *pObject );
uint32  CTOCDStd_SizeAll( CTOCDStd *pObject );
boolean CTOCDStd_Deserialize(CTOCDStd *pObject, uint8 *pBuf );
boolean CTOCDStd_Serialize(CTOCDStd *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CTOCDStd();
#endif

#endif /* #if !defined(CTOCDStd_H) */

