/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CTrapObjSvr.h  :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   WACP                                           //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined __CTRAPOBJSVRH
    #define  __CTRAPOBJSVRH

#include "CError.h"
#include "CErrSvr.h"
#include "CMsgSvr.h"
#include "Common.h"
#include "Wacp.h"
#include "InterChange.h"


typedef  enum TRAPCRSPtypSPECIES {
    TRAP_CRSP_SpNONE = 0,
    TRAP_CRSP_SpPUT_LASTERROR,
    TRAP_CRSP_SpMAX
}CRSP_SPECIES;

typedef  enum TRAPCRSttypSPECIES {
    TRAP_CRST_SpNONE = 0,
    TRAP_CRSP_SpGET_LASTERROR,
    TRAP_CRST_SpMAX
}CRST_SPECIES;

typedef struct CTrapObjSvr
{
    CError  TrapErrObj;
    CErrSvr TrapErrCfgSvr;
    CErrSvr TrapErrSvr;
    uint16  TxOptions;

}CTrapObjSvr;

/* Constructor / Destructor */
void CTrapObjSvr_Init(CTrapObjSvr *new);

/*================================================================================
CTrapObjSvr Set Error Transmission Options
================================================================================*/
boolean CTrapObjSvr_SetConfig(CTrapObjSvr *this,uint16 NewOption);

/*================================================================================
CTrapObjSvr Transmit Error Message
================================================================================*/
boolean CTrapObjSvr_TxError(CTrapObjSvr *this, uint32 ClassID, uint8 ErrorType, uint8* pBuf, uint32 Size);
boolean CTrapObjSvr_TxErrMsg(CErrSvr *pCErrSvr);

/*================================================================================
CTrapObjSvr Error Routing  
================================================================================*/
boolean CTrapObjSvr_SendError(CTrapObjSvr *this, uint32 ClassID, uint8 ErrorCode);
boolean CTrapObjSvr_RecvMsgHandler (CTrapObjSvr *this, uint8 *pBuf);

#endif //__CTrapObjSvrH
//---------------------------------------------------





