/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPDIndexer.h:                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CWACPDINDEXER_H)
    #define  CWACPDINDEXER_H

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

/*The following definition is the version.*/
#define CWCPDIDX_OBJECT_VERSION 100

typedef  enum CWCPDIDXtypSPECIES {
    CWCPDIDX_SpOBJECTINDEX = 0,
    CWCPDIDX_SpSPECIESINDEX,
    CWCPDIDX_SpBOOLEAN,
    CWCPDIDX_SpFILEINDEX,
    CWCPDIDX_SpMAX
} CWCPDIDX_SPECIES;

#define CWCPDIDX_STATIC_DATA_SIZE (SIZEOF(uint16))

typedef struct CWACPDIndexer
{
    /*DtData members*/
    uint32    ClassID;
    boolean   DirtyFlag;

    /*Static Data*/
    uint16        m_NumericID;
}CWACPDIndexer;

void    CWACPDIndexer_Init(CWACPDIndexer *new);
uint32  CWACPDIndexer_GetPayloadSize(CWACPDIndexer *pObject);
uint32  CWACPDIndexer_SizeAll(CWACPDIndexer *pObject);
boolean CWACPDIndexer_Deserialize(CWACPDIndexer *pObject, uint8 *pBuf);
boolean CWACPDIndexer_Serialize(CWACPDIndexer *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CWACPDIndexer();
#endif

#endif /* #if !defined(CWACPDINDEXER_H) */

