/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWaveSampleDStd.h:                                                //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CWAVESAMPLEDSTD_H)
    #define  CWAVESAMPLEDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif
#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

#define CWSPDSTD_OBJECT_VERSION 100
    
typedef  enum CWSPDSTDtypSPECIES {
    CWSPDSTD_SpSTANDARD = 0,
    CWSPDSTD_SpECGWAVSMP,
    CWSPDSTD_SpAUDIOWAVSMP,
    CWSPDSTD_SpECGIMPEDWAVSMP,
    CWSPDSTD_SpRWAVDETECT,
    CWSPDSTD_SpPACEWAVDETECT,
    CWSPDSTD_SpSPIROWAVSMP,
    CWSPDSTD_SpMAX
} CWSPDSTD_SPECIES;

#define CWSPDSTD_STATIC_DATA_SIZE (SIZEOF(uint32))

typedef struct CWaveSampleDStd
{
    /* DtData static members */
    uint32      ClassID;
    boolean     DirtyFlag;

    /* CWaveSampleDStd static members */
    uint32      m_SequenceNumber;

    /*Dynamic Data*/
    uint8       m_Sample[MAX_DATA_MEMBER_SIZE];
    uint16      m_SampleSize;

}CWaveSampleDStd;

void    CWaveSampleDStd_Init(CWaveSampleDStd *new, uint8 Species);
uint32  CWaveSampleDStd_GetPayloadSize(CWaveSampleDStd *pObject);
uint32  CWaveSampleDStd_SizeAll(CWaveSampleDStd *pObject);
boolean CWaveSampleDStd_Deserialize(CWaveSampleDStd *pObject, uint8* pBuf);
boolean CWaveSampleDStd_Serialize(CWaveSampleDStd *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CWaveSampleDStd();
#endif

#endif /* #if !defined(CWAVESAMPLEDSTD_H) */




