/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Common.h       :   List of common definitions                     //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(COMMON_H)
    #define  COMMON_H

#include "StdVarTyp.h"

#ifdef __cplusplus
extern "C" {
#endif

#if !defined (WIN32)
    #define INFINITE 0xFFFFFFFF
#endif

#define EVENT_BUF_SIZE 32

/* Macros for extracting the Family, Genus, and Species from
 * a bytes stream 
 */
#define GET_FAMILY(pBuf) ( pBuf[0] )
#define GET_GENUS(pBuf) ((pBuf[1] & 0xFF00) >> 8)
#define GET_SPECIES(pBuf) (pBuf[1] & 0xFF)

#define SET_FAMILY(ClassID, Family)   ((ClassID & 0x0000FFFF) | (Family << 16))
#define SET_GENUS(ClassID, Genus)    ((ClassID & 0xFFFF00FF) | (Genus << 8))
#define SET_SPECIES(ClassID, Species)  ((ClassID & 0xFFFFFF00) | Species)

#define RNDZ_PORT_DEFAULT ( 281 )
#define WACP_PORT_DEFAULT ( 282 )

typedef  enum CTStypOPTION{
    CTS_SpNONE = 0,
    CTS_SpACK,
    CTS_SpDESC,
    CTS_SpMAX
} CTS_OPTION;

#if defined( __cplusplus )
}
#endif

#endif /* #if !defined(COMMON_H) */
