/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Interchange.h  :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(INTERCHANGE_H)
    #define  INTERCHANGE_H

#include "stdvartyp.h"
#include "uart_h.h"

#define DF_PORT             (0)

#define CTL_W 0x17
#define CTL_A 0x01
#define CTL_L 0x0C

#define PREAMBLE_SIZE       (3)

typedef struct 
{
    uint8   Preamble[ PREAMBLE_SIZE ];
    uint32  PacketLen;
    uint16  Port;
    uint32	Length;
}PACKET_HDR;

/* SIZEOF(uint8) * PREAMBLE_SIZE + SIZEOF(uint32) + SIZEOF(uint16) */
#define PACKET_LITE_HEADER_SIZE 9

struct PACKET
{
    PACKET_HDR          Header;
    uint8               *DataBuffer;
    uint16              CRC;
};

#define CRCSIZE (2)

/* Callback function prototypes */
typedef void (*DataReadyEventCallBack)(uint8 *pBuf, uint32 BufSize);

/* Public Interface */
extern void InterChange_SetPort(uint16 port);
extern void InterChange_Init(DataReadyEventCallBack);
extern boolean InterChange_DeInit(void);
extern boolean InterChange_SendPacket(uint8 *pBuf, uint32 BufSize);

/* External functon prototype */
void comm_thread(void);

#endif  /* #if !defined(INTERCHANGE_H) */
