/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Wacp.h         :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   WACP                                           //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(WACP_H)
#define WACP_H

#include <stdio.h>
#include "stdvartyp.h"
#include "DtSupport.h"

#include "CError.h"
#include "CRNDZApp.h"
#include "CMsgSvr.h"
#include "CWaveSampleDStd.h"
#include "CWaveSampleCStd.h"
#include "CWaveSampleCRPDetect.h"
#include "CFlashCfgDevice.h"
#include "CFlashCfgSector.h"
#include "CFlashDSectorCRC.h"
#include "CTOCDStd.h"
#include "CFlashDSegment.h"
#include "CErrSvr.h"
#include "CTrapObjSvr.h"
#include "CFmWaveSample.h"
#include "CFmFlash.h"
#include "CFmModule.h"
#include "CModuleDStd.h"
#include "CFmTOC.h"
#include "CDeviceDStd.h"
#include "CFmDEVICE.h"
#include "CWACPDIndexer.h"
#include "InterChange.h"

#define SEND_TRAP(ClassID, ErrorType, ErrorBuf, ErrorSize) CTrapObjSvr_TxError(&TrapServer, ClassID, ErrorType, ErrorBuf, ErrorSize)

/*================================================================================
DataReadyEvent: Callback for messages received from the exchange layer.
================================================================================*/
void DataReadyEvent(uint8 *pBuf, uint32 Size);

/*================================================================================
WACP_SendMsg: Main interface method for sending a WACP message.
================================================================================*/
boolean WACP_SendMsg (uint16 Family, uint8 Genus, uint8 Species, 
                      uint8* Buffer, uint32 Size);
/*================================================================================
WACP_RecvMsg: Main interface method for receiving a WACP message.
================================================================================*/
boolean WACP_RecvMsg (uint16 Family, uint8 Genus, uint8 Species, 
                      uint8* Buffer);

/*================================================================================
WACP_AppStart: Main interface starting the WACP connection.
================================================================================*/
boolean WACP_AppStart(void);

/*================================================================================
Test: Main interface testing sending of wave samples.
================================================================================*/
void Test();

#endif /* WACP_H */


