/**************************************************************************** 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CCommSvr.h     :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(CCOMMSVR_H)
    #define  CCOMMSVR_H

#include "StdVarTyp.h"
#include "CLinkTable.h"

#define CTL_W 0x17
#define CTL_A 0x01
#define CTL_C 0x03
#define CTL_L 0x0C

#define PREAMBLE_SIZE (3)

#define MSG_HEADER (sizeof(uint8) * PREAMBLE_SIZE + sizeof(uint32))


typedef struct CCommSvr
{
    SetRecvBufPtr   pSetRecvMsg;
    TerminatePtr    pTerminate;
}CCommSvr;

void        CCommSvr_Init(CCommSvr* pObject, 
                          boolean (*RecvMsg)(char* pSourceID, uint8* pBuf, uint32 MsgSize),
                          void (*Terminate)(char* pSourceID, uint16 Port));
void        CCommSvr_Destroy(CCommSvr* pObject);
uint16      CCommSvr_GetPort(const CCommSvr* pObject, const ConnArgs* pConnArgs);
boolean     CCommSvr_SetPort(const CCommSvr* pObject, const ConnArgs* pConnArgs);
boolean     CCommSvr_Connect(CCommSvr* pObject, ConnArgs* pConnArgs);
boolean     CCommSvr_Disconnect(CCommSvr* pObject, ConnArgs* pConnArgs);
boolean     CCommSvr_SendMessage(const CCommSvr* pObject, const ConnArgs* pConnArgs, const uint8* pBuf, uint32 MsgSize);

/* Extern declaration of global function defined in Interchange.h */
uint8* GeneratePacket(uint32* OutSize, int16 Port, uint8* pBuf, uint32 Size);

#endif /* #if !defined(CCOMMSVR_H) */







