/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CMsgSvr.h      :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(CMSGSVR_H)
    #define  CMSGSVR_H

#include "StdVarTyp.h"
#include "Mem.h"
#include "Common.h"

#define CMSG_OBJECT_VERSION 100

#define MSGSVR_HEADER_SIZE (sizeof(uint32) + sizeof(uint32))

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
typedef  enum CMSGtypSPECIES {
    CMSG_SpNONE = 0,
    CMSG_SpMAX
}CMSG_SPECIES;

typedef struct CMsgSvr
{
    /* Static Data */
    uint32      ClassID;

    /*Dynamic Data*/
    uint8       *Data;
    uint32      DataSize;

    boolean     bEncryptionOn;

}CMsgSvr;



void    CMsgSvr_Init(CMsgSvr *pObject, uint16 Family, uint8 Genus, uint8 Species);
uint32  CMsgSvr_SizeAll(const CMsgSvr *pObject);
boolean CMsgSvr_Serialize(const CMsgSvr *pObject, const char *pSourceID, uint8 *pBuf);
boolean CMsgSvr_Deserialize(CMsgSvr *pObject, const char *pSourceID, uint8* pBuf);
void    CMsgSvr_SetEncryption(CMsgSvr *pObject, boolean bEncryptFlag);
boolean CMsgSvr_SetData(CMsgSvr *pObject, const char *pSourceID, const uint8 *pDataBuf, uint32 Size);

#endif /* #if !defined(CMSGSVR_H) */



