/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPEvent.c   :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#include "CWACPEvent.h"

/****************************************************************/
/*                              WIN32                           */
/****************************************************************/
void CWACPEvent_Init(CWACPEvent *pObject, const char *pName, boolean bManualReset)
{
    pObject->hHandle = CreateEvent(NULL,bManualReset,FALSE,pName);
}

void CWACPEvent_Destroy(CWACPEvent *pObject)
{
    CloseHandle(pObject->hHandle);
}

void CWACPEvent_Raise(const CWACPEvent *pObject)
{
    SetEvent(pObject->hHandle);
}

void CWACPEvent_Reset(const CWACPEvent *pObject)
{
    ResetEvent(pObject->hHandle);
}

uint32 CWACPEvent_Wait(const CWACPEvent *pObject, uint32 Timeout)
{
    uint32 Result = FALSE;
    Result = WaitForSingleObject(pObject->hHandle, Timeout);
    return(Result);
}






