/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2005-2006 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// DMOIBDefinitions.cpp                                              //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

/*
===============================================================================
    NOTE: The code in this file should not be modified by any means, and the 
    usage of macro redefinition in this file should not be duplicated by a 
    developer.
===============================================================================
*/

// Include all basic DMOIB information.
#include "DMOIBBase.h"
#include "target.h"
#include "MiscUtil.h"

// Define this macro to retain all of the array-type macros from 
// DMOIBDefiner.h
#define RETAIN_TYPE_MACROS

// Include the actual definitions once for all the prototypes and enums...
#include "DMOIBDefinitions.h"

// The DMOIBDefinitions.h file is included again multiple times to proccess
// all the macros used therein differently. Each time it is included, 
// DMOIB_DECL is redefined to perform a new step of macro processing. This
// allows all the macros in the .h file to remain the same and build all 
// necessary tables here automatically. This also means the .h file is the
// only file that needs to change for new definitions, as this .cpp file
// will always follow the same steps to reprocess the macros.

// Include the file to declare all initialization functions for static tables.
#undef  DMOIB_DEFS
#undef  DMOIB_DECL
#define DMOIB_DECL DECLARE_INITIALIZERS

#include "DMOIBDefinitions.h"

// Include the file to declare any string size constants for the string tables.
#undef  DMOIB_DEFS
#undef  DMOIB_DECL
#define DMOIB_DECL DECLARE_STRING_CONSTANTS

#include "DMOIBDefinitions.h"

// Include the file to build the actual string tables.
#undef  DMOIB_DEFS
#undef  DMOIB_DECL
#define DMOIB_DECL BUILD_STRING_TABLES

#include "DMOIBDefinitions.h"

// Include the file to add lookup information to the string tables.
#undef  DMOIB_DEFS
#undef  DMOIB_DECL
#define DMOIB_DECL BUILD_STRING_LOOKUPS

#include "DMOIBDefinitions.h"

// Include the file to implement everything else (definitions and link tables).
#undef  DMOIB_DEFS
#undef  DMOIB_DECL
#define DMOIB_DECL IMPLEMENT

#include "DMOIBDefinitions.h"

// This single function is the singleton initializer for all DMOIB static
// tables. This ensures that all tables will be fully built when they are
// requested (even if that is druing the construction of an object in the
// global space).
void DMOIBInitialize(void)
{
    // Use a static variable to flag the initialized state. This guards the
    // singleton initializer from being called multiple times.
    static char Initialized = FALSE;

    // Make sure this is the first call to initialize.
    if(Initialized == FALSE)
    {
        // Set the static flag to TRUE so this function won't be run again.
        Initialized = TRUE;
        
        // Include the file to extract the initialize functions.
        #undef  DMOIB_DEFS
        #undef  DMOIB_DECL
        #define DMOIB_DECL INITIALIZE

        #include "DMOIBDefinitions.h"
    }
}


