/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFamilyEnum.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.5.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CFAMILYENUM_H)
    #define  CFAMILYENUM_H

    typedef  enum CONNCMDtypSPECIES{
        CONN_CMD_SpSHUTDOWN = 0,
        CONN_CMD_SpMAX
    }CONN_CMD_SPECIES;

    typedef  enum RNDZCCMDtypSPECIES {
        RNDZ_CCMD_SpNONE = 0,
        RNDZ_CCMD_SpTERMINATE,
        RNDZ_CCMD_SpSTART_HOST_PROC,
        RNDZ_CCMD_SpSEND_HOST_READY,
        RNDZ_CCMD_SpMAX
    } RNDZ_CCMD_SPECIES;

    typedef  enum RNDZCRSTtypSPECIES {
        RNDZ_CRST_SpNONE = 0,
        RNDZ_CRST_SpSTART_RNDZ,
        RNDZ_CRST_SpGET_ENCRYPT_KEY,
        RNDZ_CRST_SpMAX
    } RNDZ_CRST_SPECIES;

    typedef  enum RNDZCRSPtypSPECIES {
        RNDZ_CRSP_SpNONE = 0,
        RNDZ_CRSP_SpRNDZ_ACCEPT,
        RNDZ_CRSP_SpSEND_ENCRYPT_KEY,
        RNDZ_CRSP_SpHOST_READY,
        RNDZ_CRSP_SpMAX
    } RNDZ_CRSP_SPECIES;

    /* FmERROR Message Enumerations */
    typedef enum ERRORCRSTtypSPECIES{
        ERROR_CRST_SpGET_ERROR,
        ERROR_CRST_SpMAX
    } ERROR_CRST_SPECIES;

    typedef enum ERRORCRSPtypSPECIES{
        ERROR_CRSP_SpPUT_ERROR,
        ERROR_CRSP_SpMAX
    } ERROR_CRSP_SPECIES;

    /* FmDEVICE Message Enumerations */
    typedef enum DEVICECCMDtypSPECIES{
        DEVICE_CCMD_SpWRITE_CONFIG,
        DEVICE_CCMD_SpWRITE_DATA,
        DEVICE_CCMD_SpENABLE_DISPLAY,
        DEVICE_CCMD_SpSTART_DISPLAY_TEST,
        DEVICE_CCMD_SpRESET,
        DEVICE_CCMD_SpPOWER,
        DEVICE_CCMD_SpBEEP,
        DEVICE_CCMD_SpSAVE_CONFIG,
        DEVICE_CCMD_SpRESTORE_CONFIG,
        DEVICE_CCMD_SpENABLE_AUTO_POWER_DOWN,
        DEVICE_CCMD_SpMAX
    } DEVICE_CCMD_SPECIES;

    typedef enum DEVICECRSTtypSPECIES{
        DEVICE_CRST_SpGET_DEVICEDESCRIPTION,
        DEVICE_CRST_SpGET_CONFIG,
        DEVICE_CRST_SpMAX
    } DEVICE_CRST_SPECIES;

    typedef enum DEVICECRSPtypSPECIES{
        DEVICE_CRSP_SpPUT_DEVICEDESCRIPTION,
        DEVICE_CRSP_SpPUT_CONFIG,
        DEVICE_CRSP_SpMAX
    } DEVICE_CRSP_SPECIES;

    /* FmMODULE Message Enumerations */
    typedef enum MODULECCMDtypSPECIES{
        MODULE_CCMD_SpWRITE_CONFIG,
        MODULE_CCMD_SpWRITE_MODULE_DESC,
        MODULE_CCMD_SpMAX
    } MODULE_CCMD_SPECIES;

    typedef enum MODULECRSTtypSPECIES{
        MODULE_CRST_SpGET_MODULE_DESC,
        MODULE_CRST_SpGET_CONFIG,
        MODULE_CRST_SpMAX
    } MODULE_CRST_SPECIES;

    typedef enum MODULECRSPtypSPECIES{
        MODULE_CRSP_SpPUT_MODULE_DESC,
        MODULE_CRSP_SpPUT_CONFIG,
        MODULE_CRSP_SpMAX
    } MODULE_CRSP_SPECIES;

    typedef enum MODULECEVNTtypSPECIES{
        MODULE_CEVNT_SpHW_MOD_CONNECT,
        MODULE_CEVNT_SpHW_MOD_DISCONNECT,
        MODULE_CEVNT_SpMAX
    } MODULE_CEVNT_SPECIES;

    /* FmTEMP Message Enumerations */
    typedef enum TEMPCRSTtypSPECIES{
        TEMP_CRST_SpGET_TEMP,
        TEMP_CRST_SpMAX
    } TEMP_CRST_SPECIES;

    typedef enum TEMPCRSPtypSPECIES{
        TEMP_CRSP_SpPUT_TEMP,
        TEMP_CRSP_SpMAX
    } TEMP_CRSP_SPECIES;

    typedef enum TEMPCSStypSPECIES{
        TEMP_CSS_SpREPORT_TEMPERATURE,
        TEMP_CSS_SpMAX
    } TEMP_CSS_SPECIES;

    typedef enum TEMPCSTRtypSPECIES{
        TEMP_CSTR_SpSTREAM_TEMPERATURE,
        TEMP_CSTR_SpMAX
    } TEMP_CSTR_SPECIES;

#endif /* #if !defined(CFAMILYENUM_H) */

/*---------------------------------------------------*/
/* End of File */
