REM The purpose of this bat file is to convert DDS and family files into default string and link tables that.
REM This assumes all .xml files reside in current folder and will output a LinkTable and StringTable in respective folders
REM THE XSLTs are flexible to have a single DDS with embedded families or independent family files but a DDS must be present
REM THE XML family files must have a file name ending with "Family.xml" (i.e. CDeviceFamily.xml)

mkdir LinkTables
mkdir StringTables

REM The following command line is used to output a DDS to a output file
REM Convert the DDS first to Link table. This assumes a DDS is present
REM YOU WILL NEED TO EDIT THIS LINE TO INCLUDE YOUR DDS NAME
msxsl DDS_PVSM.xml XSLT_LINKTABLE.xslt -o ./LinkTables/DDS_LinkTable.xml


REM Append each family link table to the DDS Link Table. We do not copy the first 2 lines because they already exists from transforming the DDS
for /f %%p in ('DIR /B *Family.xml') do (
findstr /vx "</LINK_TABLE>" .\LinkTables\DDS_LinkTable.xml > ./LinkTables/TempLinkTable.xml
msxsl %%p XSLT_LINKTABLE.xslt -o ./LinkTables/FamilyLinkTable.xml
more +2 .\LinkTables\FamilyLinkTable.xml >> .\LinkTables\TempLinkTable.xml
more .\LinkTables\TempLinkTable.xml > .\LinkTables\DDS_LinkTable.xml 
)
Del .\LinkTables\TempLinkTable.xml
Del .\LinkTables\FamilyLinkTable.xml


REM Convert the DDS first to string table. This assumes a DDS is present
msxsl DDS_PVSM.xml XSLT_STRINGTABLE.xslt -o ./StringTables/DDS_StringTable.xml

REM Append each family string table to the DDS StringTable. We do not copy the first 2 lines because they already exists from transforming the DDS
for /f %%p in ('DIR /B *Family.xml') do (
findstr /vx "</STRING_TABLE>" .\StringTables\DDS_StringTable.xml > ./StringTables/TempStringTable.xml
msxsl %%p XSLT_STRINGTABLE.xslt -o ./StringTables/FamilyStringTable.xml
more +2 .\StringTables\FamilyStringTable.xml >> .\StringTables\TempStringTable.xml
more .\StringTables\TempStringTable.xml > .\StringTables\DDS_StringTable.xml 
)
Del .\StringTables\TempStringTable.xml
Del .\StringTables\FamilyStringTable.xml



