/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CBMICStd.h                                                        //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CBMICSTD_H)
    #define  CBMICSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CBMICSTD_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CBMICSTDtypWEIGHTDISPLAYUNITS {
        CBMICSTD_WeightDisplayUnits_UNITS_LBS = 0, 
        CBMICSTD_WeightDisplayUnits_UNITS_KG, 
        CBMICSTD_WeightDisplayUnits_MAX
    } CBMICSTD_WEIGHTDISPLAYUNITS;

    typedef  enum CBMICSTDtypHEIGHTDISPLAYUNITS {
        CBMICSTD_HeightDisplayUnits_UNITS_INCHES = 0, 
        CBMICSTD_HeightDisplayUnits_UNITS_CENTIMETRES, 
        CBMICSTD_HeightDisplayUnits_UNITS_FEET_INCHES, 
        CBMICSTD_HeightDisplayUnits_MAX
    } CBMICSTD_HEIGHTDISPLAYUNITS;

    typedef  enum CBMICSTDtypSPECIES {
        CBMICSTD_SpSTANDARD = 0, 
        CBMICSTD_SpMAX
    } CBMICSTD_SPECIES;

#define CBMICSTD_WEIGHTDISPLAYUNITS_STRING \
    (GetMsgString((MsgEntry*)TypWeightDisplayUnitsTbl, \
                 CBMICSTD_TYPWEIGHTDISPLAYUNITSTBL_SIZE, \
                 m_structData.m_WeightDisplayUnits))

#define CBMICSTD_HEIGHTDISPLAYUNITS_STRING \
    (GetMsgString((MsgEntry*)TypHeightDisplayUnitsTbl, \
                 CBMICSTD_TYPHEIGHTDISPLAYUNITSTBL_SIZE, \
                 m_structData.m_HeightDisplayUnits))

#define CBMICSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CBMICSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CBMICStd Member's Version Enumerations*/
    typedef  enum CBMICSTDtypVERSIONS {
        CBMICSTD_Enabled,
        CBMICSTD_WeightDisplayUnits,
        CBMICSTD_HeightDisplayUnits,
        CBMICSTD_MEMBER_MAX
    } CBMICSTD_VERSIONS;

#define CBMICSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CBMICSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CBMICSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CBMICSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CBMICSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CBMICSTD_DLLAPI
    #endif
#endif

class CBMICSTD_DLLAPI CBMICStd : public DtData
{
public:
    CBMICStd();
    ~CBMICStd();

    /*---------------------------------
    CBMICStd Functions:
    ---------------------------------*/
    boolean GetEnabled();
    void SetEnabled(boolean new_Enabled);

    uint16 GetWeightDisplayUnits();
    void SetWeightDisplayUnits(uint16 new_WeightDisplayUnits);

    uint16 GetHeightDisplayUnits();
    void SetHeightDisplayUnits(uint16 new_HeightDisplayUnits);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CBMICStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            boolean       m_Enabled; /* True if enabled */
            uint16        m_WeightDisplayUnits; /* lbs or kg */
            uint16        m_HeightDisplayUnits; /* Centimeters, inches, feet inches */
    }ClassStruct_t;

#define CBMICSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 1 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypWeightDisplayUnitsTbl[];
    static const MsgEntry    TypHeightDisplayUnitsTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CBMICSTD_H) */

/*---------------------------------------------------*/
/* End of File */
