/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataTransferDExtStd.h                                            //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CDATATRANSFERDEXTSTD_H)
    #define  CDATATRANSFERDEXTSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CDTADXSTD_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDTADXSTDtypSPECIES {
        CDTADXSTD_SpSTANDARD = 0, 
        CDTADXSTD_SpMAX
    } CDTADXSTD_SPECIES;

#define CDTADXSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CDTADXSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CDataTransferDExtStd Member's Version Enumerations*/
    typedef  enum CDTADXSTDtypVERSIONS {
        CDTADXSTD_SeqNumber,
        CDTADXSTD_Identifier,
        CDTADXSTD_Data,
        CDTADXSTD_MEMBER_MAX
    } CDTADXSTD_VERSIONS;

#define CDTADXSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CDTADXSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CDATATRANSFERDEXTSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CDATATRANSFERDEXTSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CDATATRANSFERDEXTSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CDATATRANSFERDEXTSTD_DLLAPI
    #endif
#endif

class CDATATRANSFERDEXTSTD_DLLAPI CDataTransferDExtStd : public DtData
{
public:
    CDataTransferDExtStd();
    ~CDataTransferDExtStd();

    /*---------------------------------
    CDataTransferDExtStd Functions:
    ---------------------------------*/
    uint32 GetSeqNumber();
    void SetSeqNumber(uint32 new_SeqNumber);

    uint32 GetIdentifier();
    void SetIdentifier(uint32 new_Identifier);

    uint8* GetData(uint16* pSize);
    void SetData(uint8* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CDataTransferDExtStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_SeqNumber; /* Sequence Number/byte offset of current packet sent or the next requested. The sequence number is 1 based. A value of 0 indicates that it is not specified. */
            uint32        m_Identifier; /* Used to identify the Data Transfer */
    }ClassStruct_t;

#define CDTADXSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 2 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    uint8             *m_Data; /* Generic byte array that contains data */
    uint16            m_DataSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CDATATRANSFERDEXTSTD_H) */

/*---------------------------------------------------*/
/* End of File */
