/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFileSysPSelector.h                                               //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CFILESYSPSELECTOR_H)
    #define  CFILESYSPSELECTOR_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CFSYDPSEL_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CFSYDPSELtypSPECIES {
        CFSYDPSEL_SpSELECTOR = 1, 
        CFSYDPSEL_SpMAX
    } CFSYDPSEL_SPECIES;

#define CFSYDPSEL_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CFSYDPSEL_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CFileSysPSelector Member's Version Enumerations*/
    typedef  enum CFSYDPSELtypVERSIONS {
        CFSYDPSEL_PathName,
        CFSYDPSEL_StartIndex,
        CFSYDPSEL_EndIndex,
        CFSYDPSEL_MEMBER_MAX
    } CFSYDPSEL_VERSIONS;

#define CFSYDPSEL_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CFSYDPSEL_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CFILESYSPSELECTOR_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CFILESYSPSELECTOR_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CFILESYSPSELECTOR_DLLAPI  __declspec(dllimport)
    #else
        #define CFILESYSPSELECTOR_DLLAPI
    #endif
#endif

class CFILESYSPSELECTOR_DLLAPI CFileSysPSelector : public DtData
{
public:
    CFileSysPSelector();
    ~CFileSysPSelector();

    /*---------------------------------
    CFileSysPSelector Functions:
    ---------------------------------*/
    uint16 GetStartIndex();
    void SetStartIndex(uint16 new_StartIndex);

    uint16 GetEndIndex();
    void SetEndIndex(uint16 new_EndIndex);

    widechar* GetPathName(uint16* pSize);
    void SetPathName(widechar* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CFileSysPSelector *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint16        m_StartIndex; /* The starting index of the files requested. Only applicable in the GET_FILE_LIST request. The index is 1 based. A value of 0 indicates that it is not specified. */
            uint16        m_EndIndex; /* The ending index of the files requested. Only applicable in the GET_FILE_LIST request. The index is 1 based. A value of 0 indicates that it is not specified. */
    }ClassStruct_t;

#define CFSYDPSEL_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    widechar          *m_PathName; /* The PathName is the path to a folder or file. The path must start with a '\'. A trailing slash is ignored. */
    uint16            m_PathNameSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CFILESYSPSELECTOR_H) */

/*---------------------------------------------------*/
/* End of File */
