/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CHeightDStd.h                                                     //
'**  '// Version        :   1.04                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CHEIGHTDSTD_H)
    #define  CHEIGHTDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CHGTDSTD_OBJECT_VERSION 104

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CHGTDSTDtypSTATUS {
        CHGTDSTD_Status_DATA_NOT_AVAIL = 0, 
        CHGTDSTD_Status_DATA_COMPLETE, 
        CHGTDSTD_Status_DATA_FAILURE, 
        CHGTDSTD_Status_DATA_EXCEPTION, 
        CHGTDSTD_Status_DATA_PROCESSING, 
        CHGTDSTD_Status_MAX
    } CHGTDSTD_STATUS;

    typedef  enum CHGTDSTDtypEXTSTATUS {
        CHGTDSTD_ExtStatus_NONE = 0, 
        CHGTDSTD_ExtStatus_MAX
    } CHGTDSTD_EXTSTATUS;

    typedef  enum CHGTDSTDtypMODE {
        CHGTDSTD_Mode_NONE = 0, 
        CHGTDSTD_Mode_UNKNOWN, 
        CHGTDSTD_Mode_MAX
    } CHGTDSTD_MODE;

    typedef  enum CHGTDSTDtypMETHOD {
        CHGTDSTD_Method_NONE = 0, 
        CHGTDSTD_Method_UNKNOWN, 
        CHGTDSTD_Method_MANUAL, 
        CHGTDSTD_Method_DEVICE, 
        CHGTDSTD_Method_REMOTE, 
        CHGTDSTD_Method_MAX
    } CHGTDSTD_METHOD;

    typedef  enum CHGTDSTDtypSOURCE {
        CHGTDSTD_Source_NONE = 0, 
        CHGTDSTD_Source_UNKNOWN, 
        CHGTDSTD_Source_MAX
    } CHGTDSTD_SOURCE;

    typedef  enum CHGTDSTDtypSPECIES {
        CHGTDSTD_SpSTANDARD, 
        CHGTDSTD_SpMAX
    } CHGTDSTD_SPECIES;

#define CHGTDSTD_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypStatusTbl, \
                 CHGTDSTD_TYPSTATUSTBL_SIZE, \
                 m_structData.m_Status))

#define CHGTDSTD_EXTSTATUS_STRING \
    (GetMsgString((MsgEntry*)TypExtStatusTbl, \
                 CHGTDSTD_TYPEXTSTATUSTBL_SIZE, \
                 m_structData.m_ExtStatus))

#define CHGTDSTD_MODE_STRING \
    (GetMsgString((MsgEntry*)TypModeTbl, \
                 CHGTDSTD_TYPMODETBL_SIZE, \
                 m_structData.m_Mode))

#define CHGTDSTD_METHOD_STRING \
    (GetMsgString((MsgEntry*)TypMethodTbl, \
                 CHGTDSTD_TYPMETHODTBL_SIZE, \
                 m_structData.m_Method))

#define CHGTDSTD_SOURCE_STRING \
    (GetMsgString((MsgEntry*)TypSourceTbl, \
                 CHGTDSTD_TYPSOURCETBL_SIZE, \
                 m_structData.m_Source))

#define CHGTDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CHGTDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CHeightDStd Member's Version Enumerations*/
    typedef  enum CHGTDSTDtypVERSIONS {
        CHGTDSTD_STime,
        CHGTDSTD_Status,
        CHGTDSTD_Height,
        CHGTDSTD_ExtStatus,
        CHGTDSTD_Mode,
        CHGTDSTD_Method,
        CHGTDSTD_Source,
        CHGTDSTD_MEMBER_MAX
    } CHGTDSTD_VERSIONS;

#define CHGTDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CHGTDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CHEIGHTDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CHEIGHTDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CHEIGHTDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CHEIGHTDSTD_DLLAPI
    #endif
#endif

class CHEIGHTDSTD_DLLAPI CHeightDStd : public DtData
{
public:
    CHeightDStd();
    ~CHeightDStd();

    /*---------------------------------
    CHeightDStd Functions:
    ---------------------------------*/
    MOIB_TIME GetSTime();
    void SetSTime(MOIB_TIME new_STime);

    uint16 GetStatus();
    void SetStatus(uint16 new_Status);

    uint32 GetHeight();
    void SetHeight(uint32 new_Height);

    uint16 GetExtStatus();
    void SetExtStatus(uint16 new_ExtStatus);

    uint8 GetMode();
    void SetMode(uint8 new_Mode);

    uint8 GetMethod();
    void SetMethod(uint8 new_Method);

    uint16 GetSource();
    void SetSource(uint16 new_Source);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CHeightDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            MOIB_TIME     m_STime; /* Time reading was taken */
            uint16        m_Status; /* DATA_NOT_AVAIL, DATA_COMPLETE, etc */
            uint32        m_Height; /* Millimeters */
            uint16        m_ExtStatus; /* Extended status {error code} */
            uint8         m_Mode; /* Mode of operation */
            uint8         m_Method; /* Method used */
            uint16        m_Source; /* Source of data */
    }ClassStruct_t;

#define CHGTDSTD_STATIC_STRUCT_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 2 *(sizeof(uint8))   + 3 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypStatusTbl[];
    static const MsgEntry    TypExtStatusTbl[];
    static const MsgEntry    TypModeTbl[];
    static const MsgEntry    TypMethodTbl[];
    static const MsgEntry    TypSourceTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CHEIGHTDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
