/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRecordDService.h                                                 //
'**  '// Version        :   2.01                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CRECORDDSERVICE_H)
    #define  CRECORDDSERVICE_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CRCDDSVC_OBJECT_VERSION 201

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRCDDSVCtypSERVICEID {
        CRCDDSVC_ServiceID_NONE = 0, 
        CRCDDSVC_ServiceID_NIBP, 
        CRCDDSVC_ServiceID_TEMPERATURE, 
        CRCDDSVC_ServiceID_SPO2, 
        CRCDDSVC_ServiceID_HEIGHT, 
        CRCDDSVC_ServiceID_WEIGHT, 
        CRCDDSVC_ServiceID_CO2, 
        CRCDDSVC_ServiceID_RESTING_ECG, 
        CRCDDSVC_ServiceID_STRESS_ECG, 
        CRCDDSVC_ServiceID_SPIROMETRY, 
        CRCDDSVC_ServiceID_MAX
    } CRCDDSVC_SERVICEID;

    typedef  enum CRCDDSVCtypSPECIES {
        CRCDDSVC_SpSERVICE = 128, 
        CRCDDSVC_SpMAX
    } CRCDDSVC_SPECIES;

#define CRCDDSVC_SERVICEID_STRING \
    (GetMsgString((MsgEntry*)TypServiceIDTbl, \
                 CRCDDSVC_TYPSERVICEIDTBL_SIZE, \
                 m_structData.m_ServiceID))

#define CRCDDSVC_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CRCDDSVC_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CRecordDService Member's Version Enumerations*/
    typedef  enum CRCDDSVCtypVERSIONS {
        CRCDDSVC_ServiceID,
        CRCDDSVC_RecordCount,
        CRCDDSVC_LastErrorCode,
        CRCDDSVC_MEMBER_MAX
    } CRCDDSVC_VERSIONS;

#define CRCDDSVC_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CRCDDSVC_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CRECORDDSERVICE_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CRECORDDSERVICE_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CRECORDDSERVICE_DLLAPI  __declspec(dllimport)
    #else
        #define CRECORDDSERVICE_DLLAPI
    #endif
#endif

class CRECORDDSERVICE_DLLAPI CRecordDService : public DtData
{
public:
    CRecordDService();
    ~CRecordDService();

    /*---------------------------------
    CRecordDService Functions:
    ---------------------------------*/
    uint16 GetServiceID();
    void SetServiceID(uint16 new_ServiceID);

    uint32* GetRecordCount(uint16* pSize);
    void SetRecordCount(uint32* pBuf, uint16 NumElements);

    uint32* GetLastErrorCode(uint16* pSize);
    void SetLastErrorCode(uint32* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CRecordDService *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint16        m_ServiceID; /* Contains the ID of the physiologic paramter. */
    }ClassStruct_t;

#define CRCDDSVC_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    uint32            *m_RecordCount; /* An array of counts for the parameter. The structure of the array will need to be published by the device. */
    uint16            m_RecordCountSize;
    uint32            *m_LastErrorCode; /* An array of error codes that ocurred on the device */
    uint16            m_LastErrorCodeSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypServiceIDTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CRECORDDSERVICE_H) */

/*---------------------------------------------------*/
/* End of File */
