/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWeightDStd.h                                                     //
'**  '// Version        :   1.05                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CWEIGHTDSTD_H)
    #define  CWEIGHTDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CWGHDSTD_OBJECT_VERSION 105

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CWGHDSTDtypSTATUS {
        CWGHDSTD_Status_DATA_NOT_AVAIL = 0, 
        CWGHDSTD_Status_DATA_COMPLETE, 
        CWGHDSTD_Status_DATA_FAILURE, 
        CWGHDSTD_Status_DATA_EXCEPTION, 
        CWGHDSTD_Status_DATA_PROCESSING, 
        CWGHDSTD_Status_MAX
    } CWGHDSTD_STATUS;

    typedef  enum CWGHDSTDtypEXTSTATUS {
        CWGHDSTD_ExtStatus_NONE = 0, 
        CWGHDSTD_ExtStatus_MAX
    } CWGHDSTD_EXTSTATUS;

    typedef  enum CWGHDSTDtypMODE {
        CWGHDSTD_Mode_NONE = 0, 
        CWGHDSTD_Mode_UNKNOWN, 
        CWGHDSTD_Mode_MAX
    } CWGHDSTD_MODE;

    typedef  enum CWGHDSTDtypMETHOD {
        CWGHDSTD_Method_NONE = 0, 
        CWGHDSTD_Method_UNKNOWN, 
        CWGHDSTD_Method_MANUAL, 
        CWGHDSTD_Method_DEVICE, 
        CWGHDSTD_Method_REMOTE, 
        CWGHDSTD_Method_MAX
    } CWGHDSTD_METHOD;

    typedef  enum CWGHDSTDtypSOURCE {
        CWGHDSTD_Source_NONE = 0, 
        CWGHDSTD_Source_UNKNOWN, 
        CWGHDSTD_Source_TANITA = 10, 
        CWGHDSTD_Source_PELOUZE, 
        CWGHDSTD_Source_MAX
    } CWGHDSTD_SOURCE;

    typedef  enum CWGHDSTDtypSPECIES {
        CWGHDSTD_SpSTANDARD, 
        CWGHDSTD_SpMAX
    } CWGHDSTD_SPECIES;

#define CWGHDSTD_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypStatusTbl, \
                 CWGHDSTD_TYPSTATUSTBL_SIZE, \
                 m_structData.m_Status))

#define CWGHDSTD_EXTSTATUS_STRING \
    (GetMsgString((MsgEntry*)TypExtStatusTbl, \
                 CWGHDSTD_TYPEXTSTATUSTBL_SIZE, \
                 m_structData.m_ExtStatus))

#define CWGHDSTD_MODE_STRING \
    (GetMsgString((MsgEntry*)TypModeTbl, \
                 CWGHDSTD_TYPMODETBL_SIZE, \
                 m_structData.m_Mode))

#define CWGHDSTD_METHOD_STRING \
    (GetMsgString((MsgEntry*)TypMethodTbl, \
                 CWGHDSTD_TYPMETHODTBL_SIZE, \
                 m_structData.m_Method))

#define CWGHDSTD_SOURCE_STRING \
    (GetMsgString((MsgEntry*)TypSourceTbl, \
                 CWGHDSTD_TYPSOURCETBL_SIZE, \
                 m_structData.m_Source))

#define CWGHDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CWGHDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CWeightDStd Member's Version Enumerations*/
    typedef  enum CWGHDSTDtypVERSIONS {
        CWGHDSTD_STime,
        CWGHDSTD_Status,
        CWGHDSTD_Weight,
        CWGHDSTD_Stabilization,
        CWGHDSTD_ExtStatus,
        CWGHDSTD_Mode,
        CWGHDSTD_Method,
        CWGHDSTD_Source,
        CWGHDSTD_MEMBER_MAX
    } CWGHDSTD_VERSIONS;

#define CWGHDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CWGHDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CWEIGHTDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CWEIGHTDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CWEIGHTDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CWEIGHTDSTD_DLLAPI
    #endif
#endif

class CWEIGHTDSTD_DLLAPI CWeightDStd : public DtData
{
public:
    CWeightDStd();
    ~CWeightDStd();

    /*---------------------------------
    CWeightDStd Functions:
    ---------------------------------*/
    MOIB_TIME GetSTime();
    void SetSTime(MOIB_TIME new_STime);

    uint16 GetStatus();
    void SetStatus(uint16 new_Status);

    uint32 GetWeight();
    void SetWeight(uint32 new_Weight);

    boolean GetStabilization();
    void SetStabilization(boolean new_Stabilization);

    uint16 GetExtStatus();
    void SetExtStatus(uint16 new_ExtStatus);

    uint8 GetMode();
    void SetMode(uint8 new_Mode);

    uint8 GetMethod();
    void SetMethod(uint8 new_Method);

    uint16 GetSource();
    void SetSource(uint16 new_Source);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CWeightDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            MOIB_TIME     m_STime; /* Time reading was taken */
            uint16        m_Status; /* DATA_NOT_AVAIL, DATA_COMPLETE, etc */
            uint32        m_Weight; /* Grams */
            boolean       m_Stabilization; /* Set to TRUE if Status is DATA_COMPLETE, otherwise FALSE */
            uint16        m_ExtStatus; /* Extended status/error code */
            uint8         m_Mode; /* Mode of operation */
            uint8         m_Method; /* Method used */
            uint16        m_Source; /* Source of data */
    }ClassStruct_t;

#define CWGHDSTD_STATIC_STRUCT_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 2 *(sizeof(uint8))   + 3 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 1 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypStatusTbl[];
    static const MsgEntry    TypExtStatusTbl[];
    static const MsgEntry    TypModeTbl[];
    static const MsgEntry    TypMethodTbl[];
    static const MsgEntry    TypSourceTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CWEIGHTDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
