/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CError.h                                                          //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_VALIDATION_Test.xml version 0.6
'*-E************************************************************************/

#if !defined(CERROR_H)
    #define  CERROR_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CERROR_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CERRORtypERRORCODE {
        CERROR_ErrorCode_NONE = 0, 
        CERROR_ErrorCode_UNIMPL, 
        CERROR_ErrorCode_INVL_FAMILY, 
        CERROR_ErrorCode_INVL_GENUS, 
        CERROR_ErrorCode_INVL_SPECIES, 
        CERROR_ErrorCode_OBJECT_ID, 
        CERROR_ErrorCode_CRC_MISMATCH, 
        CERROR_ErrorCode_MEMORY, 
        CERROR_ErrorCode_INVL_TBL_ENTRY, 
        CERROR_ErrorCode_DUP_ENTRY, 
        CERROR_ErrorCode_INVL_PORT, 
        CERROR_ErrorCode_MAX
    } CERROR_ERRORCODE;

    typedef  enum CERRORtypAPPERROR {
        CERROR_AppError_NONE = 0, 
        CERROR_AppError_CMD_FAILED, 
        CERROR_AppError_MAX
    } CERROR_APPERROR;

    typedef  enum CERRORtypSPECIES {
        CERROR_SpERRNONE = 0, 
        CERROR_SpERRWACPSTACK, 
        CERROR_SpERRAPPINTERNAL, 
        CERROR_SpMAX
    } CERROR_SPECIES;

#define CERROR_ERRORCODE_STRING \
    (GetMsgString((MsgEntry*)TypErrorCodeTbl, \
                 CERROR_TYPERRORCODETBL_SIZE, \
                 m_structData.m_ErrorCode))

#define CERROR_APPERROR_STRING \
    (GetMsgString((MsgEntry*)TypAppErrorTbl, \
                 CERROR_TYPAPPERRORTBL_SIZE, \
                 m_structData.m_AppError))

#define CERROR_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CERROR_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CError Member's Version Enumerations*/
    typedef  enum CERRORtypVERSIONS {
        CERROR_ErrClassID,
        CERROR_ErrorCode,
        CERROR_Description,
        CERROR_Data,
        CERROR_MEMBER_MAX
    } CERROR_VERSIONS;

#define CERROR_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CERROR_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CERROR_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CERROR_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CERROR_DLLAPI  __declspec(dllimport)
    #else
        #define CERROR_DLLAPI
    #endif
#endif

class CERROR_DLLAPI CError : public DtData
{
public:
    CError();
    ~CError();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    uint32 GetErrClassID();
    void SetErrClassID(uint32 new_ErrClassID);

    uint16 GetErrorCode();
    void SetErrorCode(uint16 new_ErrorCode);

    ansichar* GetDescription(uint16* pSize);
    void SetDescription(ansichar* pBuf, uint16 Length);

    uint8* GetData(uint16* pSize);
    void SetData(uint8* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CError *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_ErrClassID; /* ClassID of message or object that generated the error */
            uint16        m_ErrorCode; /* Error code from message */
            ansichar      m_Description[20]; /* Error code description */
    }ClassStruct_t;

#define CERROR_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 20 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    uint8             *m_Data; /* Can contain any data for a received process. */
    uint16            m_DataSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypErrorCodeTbl[];
    static const MsgEntry    TypAppErrorTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CERROR_H) */

/*---------------------------------------------------*/
/* End of File */
