/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmRouter.cpp  :                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CFMROUTER_H)
    #define  CFMROUTER_H

#include "Common.h"
#include "CObjSvr.h"
#include "CTrapObjSvr.h"

typedef enum typObjSvr{
    OBJSVR_RNDZ = 0,
    OBJSVR_TRAP,
    OBJSVR_CONN,
    OBJSVR_DATA,
    OBJSVR_MAX
}OBJSVR;

class CFmRouter
{
/*================================================================================
CFmRouter Members: Public, Private, and Protected
================================================================================*/
private:
    CObjSvr* ObjSvrList[OBJSVR_MAX];
    
    CTrapObjSvr* pTrapSvr;
    void*        pWACPApp;

#if defined(TRACE_SERVER_ON) && defined(TRACE_SERVER_ON_STATUS)
    /* Trace Log Counts */
    uint32      MsgInCount;
    uint32      MsgOutCount;
#endif

public:
    CFmRouter();
    ~CFmRouter();

    void Init(CTrapObjSvr* pCTrapObjSvr, void* pWACPApp);

    /*================================================================================
    FmRouter Register object servers  
    ================================================================================*/
    boolean RegisterServer(FAMILY Family, CObjSvr* pObjSvr);

    /*================================================================================
    FmRouter Command, Response, and Request Routing  
    ================================================================================*/
    boolean RecvMsg(char* pSourceID, uint8* pBuffer, uint32 Size);
    boolean SendMsg(char* pSourceID, uint16 Family, uint8 Genus, uint8 Species, 
                     uint8* pBuffer, uint32 Size, boolean EncryptionOn);
};
#endif /* #if !defined(CFMROUTER_H) */

/*---------------------------------------------------*/
/* End of File */





