/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CObjSvr.h      :                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(COBJSVR_H)
    #define  COBJSVR_H

#include "StdVarTyp.h"  

/* Object server callback types */
typedef uint32 (*DataFuncPtr)(char*, uint32, uint8*, void*);

/* Link Layer callback types */
typedef boolean (*SendPacketFuncPtr)(char*, char*, uint8*, uint32);


class CObjSvr
{
    protected:
        uint8* pOutbuf;
    public:
        CObjSvr(){pOutbuf = NULL;};
        virtual ~CObjSvr(){pOutbuf = NULL;};
        virtual boolean RecvMsgHandler(char* pSourceID, uint8* pBuffer, void* pRouter) = 0;
        virtual boolean SendMsgHandler(char* pSourceID,
                                       uint16 Family,
                                       uint8 Genus,
                                       uint8 Species,
                                       uint8* pBuffer,
                                       uint32 Size,
                                       boolean EncryptionOn) = 0;
};
#endif /* #if !defined(COBJSVR_H) */

/*---------------------------------------------------*/
/* End of File */





