/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmDATATRANSFERStub.cpp                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmDATATRANSFERStub.h"

CFmDATATRANSFERStub::CFmDATATRANSFERStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmDATATRANSFERStub::~CFmDATATRANSFERStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmDATATRANSFERStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmDATATRANSFER Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_CONFIG\n");
                SYS_PRINTF("\t2. GET_DATA\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 2))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. REPORT_DTR\n");
                SYS_PRINTF("\t2. REPORT_DTC\n");
                SYS_PRINTF("\nEnter Status ID: ");
                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit Status Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnSTATUS, DATATRANSFER_CSS_SpREPORT_DTR, (uint8*)"STATUS: REPORT_DTR RECEIVED", (uint32)strlen("STATUS: REPORT_DTR RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    case 2:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnSTATUS, DATATRANSFER_CSS_SpREPORT_DTC, (uint8*)"STATUS: REPORT_DTC RECEIVED", (uint32)strlen("STATUS: REPORT_DTC RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    /* -- Unrecognized StatusID -- */
                    default:
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                        break;
                    }
                }
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. DATATRANSFER_CCMD_SpEXECUTE_DTT\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 1))
                    {
                        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmDATATRANSFER Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\nFmDATATRANSFER Contains No Data Objects\n");
            }
            else if(TestID == 6)
            {
                SYS_PRINTF("\nFmDATATRANSFER Contains No Streams\n");
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmDATATRANSFERStub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmDATATRANSFER, GnREQUEST, (uint8)(i%2)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmDATATRANSFERStub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnREQUEST, (uint8)(i%2), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmDATATRANSFERStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 1;
    uint8   RqstID = 0;
    uint8   NumRequest = 2;
    uint8   StatID = 0;
    uint8   NumStatus = 2;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all status */
    for(StatID = 0; StatID < NumStatus; StatID++)
    {
        switch(StatID)
        {
            case DATATRANSFER_CSS_SpREPORT_DTR:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnSTATUS, DATATRANSFER_CSS_SpREPORT_DTR, (uint8*)"STATUS: REPORT_DTR RECEIVED", (uint32)strlen("STATUS: REPORT_DTR RECEIVED")+1, FALSE);
#endif
                break;
            }
            case DATATRANSFER_CSS_SpREPORT_DTC:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmDATATRANSFER, GnSTATUS, DATATRANSFER_CSS_SpREPORT_DTC, (uint8*)"STATUS: REPORT_DTC RECEIVED", (uint32)strlen("STATUS: REPORT_DTC RECEIVED")+1, FALSE);
#endif
                break;
            }
        }
    }

#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
