/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmFLASHStub.cpp                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmFLASHStub.h"

CFmFLASHStub::CFmFLASHStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmFLASHStub::~CFmFLASHStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmFLASHStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmFLASH Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_CRC\n");
                SYS_PRINTF("\t2. GET_SEGMENT\n");
                SYS_PRINTF("\t3. GT_FLASH_CONFIG\n");
                SYS_PRINTF("\t4. GET_SECTOR_CONFIG\n");
                SYS_PRINTF("\t5. GET_UPGRADE\n");
                SYS_PRINTF("\t6. GET_FLASH_PREPARATION\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 6))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmFLASH, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. FLASH_READY\n");
                SYS_PRINTF("\t2. FLASH_COMPLETE\n");
                SYS_PRINTF("\nEnter Status ID: ");
                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit Status Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmFLASH, GnSTATUS, FLASH_CSS_SpFLASH_READY, (uint8*)"STATUS: FLASH_READY RECEIVED", (uint32)strlen("STATUS: FLASH_READY RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    case 2:
                    {
#if defined(DEBUG_PRINT_STATUS)
                        pStubClass->SendMsg(pSourceID, FmFLASH, GnSTATUS, FLASH_CSS_SpFLASH_COMPLETE, (uint8*)"STATUS: FLASH_COMPLETE RECEIVED", (uint32)strlen("STATUS: FLASH_COMPLETE RECEIVED")+1, FALSE);
#endif
                        break;
                    }
                    /* -- Unrecognized StatusID -- */
                    default:
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                        break;
                    }
                }
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. FLASH_CCMD_SpWRITE_SEGMENT\n");
                SYS_PRINTF("\t2. FLASH_CCMD_SpERASE_SECTOR\n");
                SYS_PRINTF("\t3. FLASH_CCMD_SpENABLE_FLASH\n");
                SYS_PRINTF("\t4. FLASH_CCMD_SpDISABLE_FLASH\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 4))
                    {
                        pStubClass->SendMsg(pSourceID, FmFLASH, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmFLASH Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\nFmFLASH Contains No Data Objects\n");
            }
            else if(TestID == 6)
            {
                SYS_PRINTF("\nFmFLASH Contains No Streams\n");
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmFLASHStub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmFLASH, GnREQUEST, (uint8)(i%6)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmFLASHStub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmFLASH, GnREQUEST, (uint8)(i%6), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmFLASHStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 4;
    uint8   RqstID = 0;
    uint8   NumRequest = 6;
    uint8   StatID = 0;
    uint8   NumStatus = 2;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmFLASH, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmFLASH, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all status */
    for(StatID = 0; StatID < NumStatus; StatID++)
    {
        switch(StatID)
        {
            case FLASH_CSS_SpFLASH_READY:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmFLASH, GnSTATUS, FLASH_CSS_SpFLASH_READY, (uint8*)"STATUS: FLASH_READY RECEIVED", (uint32)strlen("STATUS: FLASH_READY RECEIVED")+1, FALSE);
#endif
                break;
            }
            case FLASH_CSS_SpFLASH_COMPLETE:
            {
#if defined(DEBUG_PRINT_STATUS)
                pStubClass->SendMsg(pSourceID, FmFLASH, GnSTATUS, FLASH_CSS_SpFLASH_COMPLETE, (uint8*)"STATUS: FLASH_COMPLETE RECEIVED", (uint32)strlen("STATUS: FLASH_COMPLETE RECEIVED")+1, FALSE);
#endif
                break;
            }
        }
    }

#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
