/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmMODULEStub.cpp                                                 //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmMODULEStub.h"

CFmMODULEStub::CFmMODULEStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmMODULEStub::~CFmMODULEStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmMODULEStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;
    uint8    *ObjBuffer = NULL;
    uint32   ObjSize = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmMODULE Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_MODULE_DESC\n");
                SYS_PRINTF("\t2. GET_CONFIG\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 2))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\nFmMODULE Contains No Status Messages\n");
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. MODULE_CCMD_SpWRITE_CONFIG\n");
                SYS_PRINTF("\t2. MODULE_CCMD_SpWRITE_MODULE_DESC\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 2))
                    {
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
               char Temp[] = "Test message";

               SYS_PRINTF("\t0. Exit\n");
               SYS_PRINTF("\t1. MODULE_CEVNT_SpHW_MOD_CONNECT_Event\n");
               SYS_PRINTF("\t2. MODULE_CEVNT_SpHW_MOD_DISCONNECT_Event\n");

               SYS_PRINTF("\nEnter Event ID: ");

               Result = (uint16)scanf("%d", &CmdRqst);
               if(Result == 1)
               {
                   if(CmdRqst == 0)
                   {
                       SYS_PRINTF("\n\nExit Event Menu.\n\n");
                       break;
                   }
                   else if((CmdRqst >= 1) && (CmdRqst <= 2))
                   {
                       pStubClass->SendMsg(pSourceID, FmMODULE, GnEVENT, (uint8)--CmdRqst, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);
                   }
                   else
                   {
                       SYS_PRINTF("\n\nInvalid Selection.\n\n");
                   }
               }
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. Send CMODDSTD_SpSTANDARD\n");
                SYS_PRINTF("\t2. Send CMODDSTD_SpHOST\n");
                SYS_PRINTF("\t3. Send CMODDSTD_SpHARDWARE\n");
                SYS_PRINTF("\t4. Send CMODDSTD_SpBOOTLOADER\n");
                SYS_PRINTF("\t5. Send CMODDSTD_SpBOOTRECOVERY\n");
                SYS_PRINTF("\t6. Send CMODDSTD_SpINITBOOTLOADER\n");
                SYS_PRINTF("\t7. Send CMODDSTD_SpOPERATINGSYSTEM\n");
                SYS_PRINTF("\t8. Send CMODDSTD_SpFONT\n");
                SYS_PRINTF("\t9. Send CMODDSTD_SpAUXILIARYHOST\n");
                SYS_PRINTF("\t10. Send CMODDSTD_SpAUXILIARYHARDWARE\n");
                SYS_PRINTF("\t11. Send CMODDSTD_SpAUXILIARYBOOTLOADER\n");
                SYS_PRINTF("\t12. Send CMODDSTD_SpAUXILIARYOPERATINGSYSTEM\n");
                SYS_PRINTF("\t13. Send CMODDSTD_SpNIBPMODULE\n");
                SYS_PRINTF("\t14. Send CMODDSTD_SpNIBPSAFETYALG\n");
                SYS_PRINTF("\t15. Send CMODDSTD_SpNIBPSTEPALG\n");
                SYS_PRINTF("\t16. Send CMODDSTD_SpNIBPFASTALG\n");
                SYS_PRINTF("\t17. Send CMODDSTD_SpNIBPNEONATSTEPALG\n");
                SYS_PRINTF("\t18. Send CMODDSTD_SpNIBPPOEMALG\n");
                SYS_PRINTF("\t19. Send CMODDSTD_SpNIBPSTEPAOALG\n");
                SYS_PRINTF("\t20. Send CMODDSTD_SpTEMPMODULE\n");
                SYS_PRINTF("\t21. Send CMODDSTD_SpSURETEMPALG\n");
                SYS_PRINTF("\t22. Send CMODDSTD_SpSPO2MODULE\n");
                SYS_PRINTF("\t23. Send CMODDSTD_SpECGMODULE\n");
                SYS_PRINTF("\t24. Send CMODDSTD_SpMEANS\n");
                SYS_PRINTF("\t25. Send CMODDSTD_SpSPIROMETRY\n");
                SYS_PRINTF("\t26. Send CMODDSTD_SpCO2MODULE\n");
                SYS_PRINTF("\t27. Send CMODDSTD_SpFRONTEND\n");
                SYS_PRINTF("\t28. Send CMODDSTD_SpPPP\n");
                SYS_PRINTF("\t29. Send CMODDSTD_SpSECUREDIGITALCARD\n");
                SYS_PRINTF("\t30. Send CMODDSTD_SpPRINTER\n");
                SYS_PRINTF("\t31. Send CMODDSTD_SpCOMMSMODULE\n");
                SYS_PRINTF("\t32. Send CMODDSTD_SpRADIO\n");
                SYS_PRINTF("\t33. Send CMODDSTD_SpBARCODE\n");
                SYS_PRINTF("\t34. Send CMODDSTD_SpSCALE\n");
                SYS_PRINTF("\t35. Send CMODDSTD_SpBATTERY\n");
                SYS_PRINTF("\t36. Send CMODDSTD_SpALL\n");
                SYS_PRINTF("\nEnter DataObject: ");

                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit DataObject Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSTANDARD);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSTANDARD, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 2:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpHOST);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpHOST, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 3:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpHARDWARE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpHARDWARE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 4:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBOOTLOADER);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBOOTLOADER, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 5:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBOOTRECOVERY);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBOOTRECOVERY, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 6:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpINITBOOTLOADER);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpINITBOOTLOADER, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 7:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpOPERATINGSYSTEM);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpOPERATINGSYSTEM, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 8:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpFONT);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpFONT, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 9:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYHOST);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYHOST, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 10:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYHARDWARE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYHARDWARE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 11:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYBOOTLOADER);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYBOOTLOADER, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 12:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYOPERATINGSYSTEM);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYOPERATINGSYSTEM, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 13:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPMODULE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPMODULE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 14:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPSAFETYALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPSAFETYALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 15:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPSTEPALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPSTEPALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 16:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPFASTALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPFASTALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 17:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPNEONATSTEPALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPNEONATSTEPALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 18:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPPOEMALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPPOEMALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 19:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPSTEPAOALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPSTEPAOALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 20:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpTEMPMODULE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpTEMPMODULE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 21:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSURETEMPALG);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSURETEMPALG, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 22:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSPO2MODULE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSPO2MODULE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 23:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpECGMODULE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpECGMODULE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 24:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpMEANS);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpMEANS, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 25:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSPIROMETRY);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSPIROMETRY, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 26:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpCO2MODULE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpCO2MODULE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 27:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpFRONTEND);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpFRONTEND, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 28:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpPPP);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpPPP, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 29:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSECUREDIGITALCARD);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSECUREDIGITALCARD, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 30:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpPRINTER);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpPRINTER, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 31:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpCOMMSMODULE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpCOMMSMODULE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 32:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpRADIO);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpRADIO, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 33:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBARCODE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBARCODE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 34:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSCALE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSCALE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 35:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBATTERY);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBATTERY, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 36:
                    {
                        pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpALL);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpALL, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                }
            }
            else if(TestID == 6)
            {
                SYS_PRINTF("\nFmMODULE Contains No Streams\n");
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */

    /* Clean up the memory allocations */
    SYS_FREE(ObjBuffer);
    ObjBuffer = NULL;
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmMODULEStub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmMODULE, GnREQUEST, (uint8)(i%2)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmMODULEStub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmMODULE, GnREQUEST, (uint8)(i%2), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmMODULEStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 2;
    uint8   RqstID = 0;
    uint8   NumRequest = 2;
    uint8   EvntID = 0;
    uint8   NumEvent = 2;
    char    Temp[] = "Test message";
    uint32  Result;
    uint8   *ObjBuffer = NULL;
    uint32  ObjSize = 0;
    uint8   DataID = 0;
    uint8   NumDataObject = 54;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmMODULE, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmMODULE, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all events */
    for(EvntID = 0; EvntID < NumEvent; EvntID++)
        pStubClass->SendMsg(pSourceID, FmMODULE, GnEVENT, EvntID, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);

    /* Send all data objects */
    for(DataID = 0; DataID < NumDataObject; DataID++)
    {
        switch(DataID)
        {
            case 0:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSTANDARD);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSTANDARD, ObjBuffer, ObjSize);
                }
                break;
            }
            case 1:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpHOST);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpHOST, ObjBuffer, ObjSize);
                }
                break;
            }
            case 2:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpHARDWARE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpHARDWARE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 3:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBOOTLOADER);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBOOTLOADER, ObjBuffer, ObjSize);
                }
                break;
            }
            case 4:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBOOTRECOVERY);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBOOTRECOVERY, ObjBuffer, ObjSize);
                }
                break;
            }
            case 5:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpINITBOOTLOADER);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpINITBOOTLOADER, ObjBuffer, ObjSize);
                }
                break;
            }
            case 6:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpOPERATINGSYSTEM);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpOPERATINGSYSTEM, ObjBuffer, ObjSize);
                }
                break;
            }
            case 7:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpFONT);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpFONT, ObjBuffer, ObjSize);
                }
                break;
            }
            case 8:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYHOST);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYHOST, ObjBuffer, ObjSize);
                }
                break;
            }
            case 9:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYHARDWARE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYHARDWARE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 10:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYBOOTLOADER);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYBOOTLOADER, ObjBuffer, ObjSize);
                }
                break;
            }
            case 11:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpAUXILIARYOPERATINGSYSTEM);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpAUXILIARYOPERATINGSYSTEM, ObjBuffer, ObjSize);
                }
                break;
            }
            case 12:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPMODULE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPMODULE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 13:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPSAFETYALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPSAFETYALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 14:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPSTEPALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPSTEPALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 15:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPFASTALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPFASTALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 16:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPNEONATSTEPALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPNEONATSTEPALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 17:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPPOEMALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPPOEMALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 18:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpNIBPSTEPAOALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpNIBPSTEPAOALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 19:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpTEMPMODULE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpTEMPMODULE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 20:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSURETEMPALG);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSURETEMPALG, ObjBuffer, ObjSize);
                }
                break;
            }
            case 21:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSPO2MODULE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSPO2MODULE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 22:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpECGMODULE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpECGMODULE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 23:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpMEANS);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpMEANS, ObjBuffer, ObjSize);
                }
                break;
            }
            case 24:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSPIROMETRY);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSPIROMETRY, ObjBuffer, ObjSize);
                }
                break;
            }
            case 25:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpCO2MODULE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpCO2MODULE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 26:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpFRONTEND);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpFRONTEND, ObjBuffer, ObjSize);
                }
                break;
            }
            case 27:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpPPP);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpPPP, ObjBuffer, ObjSize);
                }
                break;
            }
            case 28:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSECUREDIGITALCARD);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSECUREDIGITALCARD, ObjBuffer, ObjSize);
                }
                break;
            }
            case 29:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpPRINTER);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpPRINTER, ObjBuffer, ObjSize);
                }
                break;
            }
            case 30:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpCOMMSMODULE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpCOMMSMODULE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 31:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpRADIO);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpRADIO, ObjBuffer, ObjSize);
                }
                break;
            }
            case 32:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBARCODE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBARCODE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 33:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpSCALE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpSCALE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 34:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpBATTERY);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpBATTERY, ObjBuffer, ObjSize);
                }
                break;
            }
            case 35:
            {
                pStubClass->pCModuleDStd->set_Species(CMODDSTD_SpALL);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCModuleDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCModuleDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmMODULE, GnDATA, CMODDSTD_SpALL, ObjBuffer, ObjSize);
                }
                break;
            }
        }
    }
    /* clean up */
    SYS_FREE(ObjBuffer);
#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
