/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmNUMERICStub.cpp                                                //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmNUMERICStub.h"

CFmNUMERICStub::CFmNUMERICStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmNUMERICStub::~CFmNUMERICStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmNUMERICStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;
    uint8    *ObjBuffer = NULL;
    uint32   ObjSize = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmNUMERIC Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\nFmNUMERIC Contains No Requests\n");
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\nFmNUMERIC Contains No Status Messages\n");
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. NUMERIC_CCMD_SpCMD_START_ACQUIRE\n");
                SYS_PRINTF("\t2. NUMERIC_CCMD_SpCMD_STOP_ACQUIRE\n");
                SYS_PRINTF("\t3. NUMERIC_CCMD_SpWRITE_CONFIG\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 3))
                    {
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmNUMERIC Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. Send CNUMDSTD_SpSTANDARD\n");
                SYS_PRINTF("\t2. Send CNUMDSTD_SpECGHR\n");
                SYS_PRINTF("\t3. Send CNUMDSTD_SpHRPR\n");
                SYS_PRINTF("\t4. Send CNUMDSTD_SpNIBPSYS\n");
                SYS_PRINTF("\t5. Send CNUMDSTD_SpNIBPDIA\n");
                SYS_PRINTF("\t6. Send CNUMDSTD_SpNIBPMAP\n");
                SYS_PRINTF("\t7. Send CNUMDSTD_SpNIBPPR\n");
                SYS_PRINTF("\t8. Send CNUMDSTD_SpIBP1SYS\n");
                SYS_PRINTF("\t9. Send CNUMDSTD_SpIBP1DIA\n");
                SYS_PRINTF("\t10. Send CNUMDSTD_SpIBP1MAP\n");
                SYS_PRINTF("\t11. Send CNUMDSTD_SpIBP1PR\n");
                SYS_PRINTF("\t12. Send CNUMDSTD_SpIBP2SYS\n");
                SYS_PRINTF("\t13. Send CNUMDSTD_SpIBP2DIA\n");
                SYS_PRINTF("\t14. Send CNUMDSTD_SpIBP2MAP\n");
                SYS_PRINTF("\t15. Send CNUMDSTD_SpIBP2PR\n");
                SYS_PRINTF("\t16. Send CNUMDSTD_SpIBP3SYS\n");
                SYS_PRINTF("\t17. Send CNUMDSTD_SpIBP3DIA\n");
                SYS_PRINTF("\t18. Send CNUMDSTD_SpIBP3MAP\n");
                SYS_PRINTF("\t19. Send CNUMDSTD_SpIBP3PR\n");
                SYS_PRINTF("\t20. Send CNUMDSTD_SpSPO2PR\n");
                SYS_PRINTF("\t21. Send CNUMDSTD_SpSPO2SAT\n");
                SYS_PRINTF("\t22. Send CNUMDSTD_SpSPO2PI\n");
                SYS_PRINTF("\t23. Send CNUMDSTD_SpRESPRATE\n");
                SYS_PRINTF("\t24. Send CNUMDSTD_SpRRBR\n");
                SYS_PRINTF("\t25. Send CNUMDSTD_SpCO2ENDT\n");
                SYS_PRINTF("\t26. Send CNUMDSTD_SpCO2INSP\n");
                SYS_PRINTF("\t27. Send CNUMDSTD_SpCO2BR\n");
                SYS_PRINTF("\t28. Send CNUMDSTD_SpTEMP1\n");
                SYS_PRINTF("\t29. Send CNUMDSTD_SpTEMP2\n");
                SYS_PRINTF("\t30. Send CNUMDSTD_SpDELTAT\n");
                SYS_PRINTF("\t31. Send CNUMDSTD_SpALL\n");
                SYS_PRINTF("\nEnter DataObject: ");

                Result = (uint16)scanf("%d", &CmdRqst);

                switch(CmdRqst)
                {
                    case 0:
                    {
                        SYS_PRINTF("\n\nExit DataObject Menu.\n\n");
                        break;
                    }
                    case 1:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSTANDARD);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSTANDARD, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 2:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpECGHR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpECGHR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 3:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpHRPR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpHRPR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 4:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPSYS);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPSYS, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 5:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPDIA);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPDIA, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 6:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPMAP);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPMAP, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 7:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPPR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPPR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 8:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1SYS);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1SYS, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 9:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1DIA);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1DIA, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 10:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1MAP);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1MAP, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 11:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1PR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1PR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 12:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2SYS);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2SYS, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 13:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2DIA);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2DIA, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 14:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2MAP);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2MAP, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 15:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2PR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2PR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 16:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3SYS);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3SYS, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 17:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3DIA);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3DIA, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 18:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3MAP);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3MAP, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 19:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3PR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3PR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 20:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSPO2PR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSPO2PR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 21:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSPO2SAT);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSPO2SAT, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 22:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSPO2PI);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSPO2PI, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 23:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpRESPRATE);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpRESPRATE, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 24:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpRRBR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpRRBR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 25:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpCO2ENDT);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpCO2ENDT, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 26:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpCO2INSP);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpCO2INSP, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 27:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpCO2BR);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpCO2BR, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 28:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpTEMP1);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpTEMP1, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 29:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpTEMP2);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpTEMP2, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 30:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpDELTAT);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpDELTAT, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                    case 31:
                    {
                        pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpALL);
                        if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                        {
                            Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                            if(Result)
                                pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpALL, ObjBuffer, ObjSize);
                        }
                        break;
                    }
                }
            }
            else if(TestID == 6)
            {
               char Temp[] = "Test message";

               SYS_PRINTF("\t0. Exit\n");
               SYS_PRINTF("\t1. NUMERIC_CSTR_SpSTREAM_NUMERIC\n");

               SYS_PRINTF("\nEnter Stream ID: ");

               Result = (uint16)scanf("%d", &CmdRqst);
               if(Result == 1)
               {
                   if(CmdRqst == 0)
                   {
                       SYS_PRINTF("\n\nExit Stream Menu.\n\n");
                       break;
                   }
                   else if((CmdRqst >= 1) && (CmdRqst <= 1))
                   {
                       pStubClass->SendMsg(pSourceID, FmNUMERIC, GnSTREAM, (uint8)--CmdRqst, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);
                   }
                   else
                   {
                       SYS_PRINTF("\n\nInvalid Selection.\n\n");
                   }
               }
            }
            else if(TestID == 7)
            {
                SYS_PRINTF("FmNUMERIC Contains No Request messages\n");
            }
            else if(TestID == 8)
            {
                SYS_PRINTF("FmNUMERIC Contains No Request messages\n");
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */

    /* Clean up the memory allocations */
    SYS_FREE(ObjBuffer);
    ObjBuffer = NULL;
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmNUMERICStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 3;
    uint8   StrmID = 0;
    uint8   NumStream = 1;
    char    Temp[] = "Test message";
    uint32  Result;
    uint8   *ObjBuffer = NULL;
    uint32  ObjSize = 0;
    uint8   DataID = 0;
    uint8   NumDataObject = 46;

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnCOMMAND, CmdID, NULL, 0, FALSE);

    /* Send all streams */
    for(StrmID = 0; StrmID < NumStream; StrmID++)
        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnSTREAM, StrmID, (uint8*)Temp, (uint32)strlen(Temp) + 1, FALSE);

    /* Send all data objects */
    for(DataID = 0; DataID < NumDataObject; DataID++)
    {
        switch(DataID)
        {
            case 0:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSTANDARD);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSTANDARD, ObjBuffer, ObjSize);
                }
                break;
            }
            case 1:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpECGHR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpECGHR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 2:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpHRPR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpHRPR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 3:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPSYS);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPSYS, ObjBuffer, ObjSize);
                }
                break;
            }
            case 4:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPDIA);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPDIA, ObjBuffer, ObjSize);
                }
                break;
            }
            case 5:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPMAP);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPMAP, ObjBuffer, ObjSize);
                }
                break;
            }
            case 6:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpNIBPPR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpNIBPPR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 7:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1SYS);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1SYS, ObjBuffer, ObjSize);
                }
                break;
            }
            case 8:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1DIA);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1DIA, ObjBuffer, ObjSize);
                }
                break;
            }
            case 9:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1MAP);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1MAP, ObjBuffer, ObjSize);
                }
                break;
            }
            case 10:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP1PR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP1PR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 11:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2SYS);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2SYS, ObjBuffer, ObjSize);
                }
                break;
            }
            case 12:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2DIA);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2DIA, ObjBuffer, ObjSize);
                }
                break;
            }
            case 13:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2MAP);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2MAP, ObjBuffer, ObjSize);
                }
                break;
            }
            case 14:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP2PR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP2PR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 15:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3SYS);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3SYS, ObjBuffer, ObjSize);
                }
                break;
            }
            case 16:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3DIA);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3DIA, ObjBuffer, ObjSize);
                }
                break;
            }
            case 17:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3MAP);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3MAP, ObjBuffer, ObjSize);
                }
                break;
            }
            case 18:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpIBP3PR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpIBP3PR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 19:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSPO2PR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSPO2PR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 20:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSPO2SAT);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSPO2SAT, ObjBuffer, ObjSize);
                }
                break;
            }
            case 21:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpSPO2PI);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpSPO2PI, ObjBuffer, ObjSize);
                }
                break;
            }
            case 22:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpRESPRATE);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpRESPRATE, ObjBuffer, ObjSize);
                }
                break;
            }
            case 23:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpRRBR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpRRBR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 24:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpCO2ENDT);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpCO2ENDT, ObjBuffer, ObjSize);
                }
                break;
            }
            case 25:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpCO2INSP);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpCO2INSP, ObjBuffer, ObjSize);
                }
                break;
            }
            case 26:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpCO2BR);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpCO2BR, ObjBuffer, ObjSize);
                }
                break;
            }
            case 27:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpTEMP1);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpTEMP1, ObjBuffer, ObjSize);
                }
                break;
            }
            case 28:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpTEMP2);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpTEMP2, ObjBuffer, ObjSize);
                }
                break;
            }
            case 29:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpDELTAT);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpDELTAT, ObjBuffer, ObjSize);
                }
                break;
            }
            case 30:
            {
                pStubClass->pCNumDStd->set_Species(CNUMDSTD_SpALL);
                if((ObjBuffer = (uint8*)SYS_REALLOC(ObjBuffer, ObjSize = pStubClass->pCNumDStd->size_all())) != NULL)
                {
                    Result = pStubClass->pCNumDStd->serialize_all(ObjBuffer);
                    if(Result)
                        pStubClass->SendMsg(pSourceID, FmNUMERIC, GnDATA, CNUMDSTD_SpALL, ObjBuffer, ObjSize);
                }
                break;
            }
        }
    }
    /* clean up */
    SYS_FREE(ObjBuffer);
#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
