/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataTransferCDesc.h                                              //
'**  '// Version        :   2.01                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CDATATRANSFERCDESC_H)
    #define  CDATATRANSFERCDESC_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDTACDSCtypROLE {
        CDTACDSC_Role_NONE = 0, /*Indicates that a role is not specified*/
        CDTACDSC_Role_DATA_RECIPIENT, /*Indicates that the data source doesn't reside in the application and will be requested*/
        CDTACDSC_Role_DATA_SOURCE, /*Indicates that the data source resides on the application and will serve data.*/
        CDTACDSC_Role_MAX
    } CDTACDSC_ROLE;

    typedef  enum CDTACDSCtypSPECIES {
        CDTACDSC_SpDESCRIPTION = 1, /*Indicates it is a description of a proposed data transfer*/
        CDTACDSC_SpMAX
    } CDTACDSC_SPECIES;

    /*CDataTransferCDesc Member's Version Enumerations*/
    typedef  enum CDTACDSCtypVERSIONS {
        CDTACDSC_InitSeqNumber,
        CDTACDSC_TotalDataSize,
        CDTACDSC_DataPacketSize,
        CDTACDSC_Role,
        CDTACDSC_Identifier,
        CDTACDSC_Descriptor,
        CDTACDSC_WindowSize,
        CDTACDSC_MEMBER_MAX
    } CDTACDSC_VERSIONS;


/*The following definition is the version.*/
#define CDTACDSC_OBJECT_VERSION 201

#define CDTACDSC_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CDTACDSC_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 1 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 3 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CDataTransferCDesc
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_InitSeqNumber; /* Initial sequence number/byte offset of the data transfer. The sequence number is 1 based. A value of 0 indicates that it is not specified. */
    uint32             m_TotalDataSize; /* Total size of data being sent in bytes. */
    uint16             m_DataPacketSize; /* Maximum number of bytes in a 'packet' found in CDataTransferDExtStd::Data. The host/client will propose the max packet size in the intial configuration request and the client/host will respond with its agreed upon size (less than equal to initiator's max size) */
    uint8              m_Role; /* Describes where the Data is being transferred from. */
    uint32             m_Identifier; /* Used to uniquely identify the Data Transfer. */
    uint16             m_WindowSize; /* Identifies the number of outstanding request messages that can be received before the first response. A value of 0 indicates that it is not specified. Populated by the DATA_SOURCE */

    /*Record Data*/
    uint8    *m_Descriptor;
    uint32   m_DescriptorSize;
    uint32   m_DescriptorMaxSize;
    uint16   m_DescriptorElements;
    boolean  bDescriptorMaxSize;

}CDataTransferCDesc;

void    CDataTransferCDesc_Init(CDataTransferCDesc *pObject);
void    CDataTransferCDesc_Reset(CDataTransferCDesc *pObject, boolean bResetAll, boolean bInit);
uint32  CDataTransferCDesc_SizeAll(const CDataTransferCDesc *pObject);
boolean CDataTransferCDesc_Deserialize(CDataTransferCDesc *pObject, uint8 *pBuf);
boolean CDataTransferCDesc_Serialize(const CDataTransferCDesc *pObject, uint8 *pBuf);

boolean  CDataTransferCDesc_InitDescriptor(CDataTransferCDesc *pObject, uint32 Size);
boolean  CDataTransferCDesc_AppendDescriptor(CDataTransferCDesc *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements);
boolean  CDataTransferCDesc_DeleteDescriptor(CDataTransferCDesc *pObject);
uint8*   CDataTransferCDesc_GetDescriptorAt(CDataTransferCDesc *pObject, uint16 Index, uint32 *pSize);
uint8*   CDataTransferCDesc_GetDescriptor(CDataTransferCDesc *pObject, uint32 *pSize);

#endif /* #if !defined(CDATATRANSFERCDESC_H) */

