/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDevPMsgArguments.h                                               //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CDEVPMSGARGUMENTS_H)
    #define  CDEVPMSGARGUMENTS_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVPARGtypDEVICEMODE {
        CDEVPARG_DeviceMode_NONE = 0, /*None specified*/
        CDEVPARG_DeviceMode_NORMAL = 1, /*Measurement (Normal) mode*/
        CDEVPARG_DeviceMode_STANDBY = 2, /*Standby mode*/
        CDEVPARG_DeviceMode_CALIBRATION = 3, /*Calibration mode*/
        CDEVPARG_DeviceMode_SERVICE = 4, /*Service (Software Download) mode*/
        CDEVPARG_DeviceMode_DEMO = 5, /*Demo Mode*/
        CDEVPARG_DeviceMode_ATE = 6, /*ATE Test Mode*/
        CDEVPARG_DeviceMode_MAX
    } CDEVPARG_DEVICEMODE;

    typedef  enum CDEVPARGtypSPECIES {
        CDEVPARG_SpMSG_ARGUMENTS = 0, /*Indicates that the object is a message argument rather than a result.*/
        CDEVPARG_SpRESULT = 1, /*Indicates that the object is a Result rather than a message argument. Used with CDevPMsgArguments objects in PUT_DIGITAL_STATE messages*/
        CDEVPARG_SpMAX
    } CDEVPARG_SPECIES;

    /*CDevPMsgArguments Member's Version Enumerations*/
    typedef  enum CDEVPARGtypVERSIONS {
        CDEVPARG_SpeciesSelector,
        CDEVPARG_IOParameterA,
        CDEVPARG_MEMBER_MAX
    } CDEVPARG_VERSIONS;


/*The following definition is the version.*/
#define CDEVPARG_OBJECT_VERSION 101

#define CDEVPARG_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CDEVPARG_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 2 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CDevPMsgArguments
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_SpeciesSelector; /* Species ID of the device requested. */
    uint32             m_IOParameterA; /* IO parameter for device message. */

}CDevPMsgArguments;

void    CDevPMsgArguments_Init(CDevPMsgArguments *pObject);
void    CDevPMsgArguments_Reset(CDevPMsgArguments *pObject, boolean bResetAll, boolean bInit);
uint32  CDevPMsgArguments_SizeAll(const CDevPMsgArguments *pObject);
boolean CDevPMsgArguments_Deserialize(CDevPMsgArguments *pObject, uint8 *pBuf);
boolean CDevPMsgArguments_Serialize(const CDevPMsgArguments *pObject, uint8 *pBuf);

#endif /* #if !defined(CDEVPMSGARGUMENTS_H) */

