/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDExtStd.c                                                  //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CDeviceDExtStd.h"

#define CDEVDXTSTD_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CDeviceDExtStd_TypVersionsTbl, \
                      CDEVDXTSTD_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CDeviceDExtStd_TypVersionsTbl[CDEVDXTSTD_MEMBER_MAX] = {
    200, 200, /*CDEVICEDEXTSTD_DeviceContainer*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CDeviceDExtStd_Init(CDeviceDExtStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CDeviceDExtStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmDEVICE, GnDATAEXT, CDEVDXTSTD_SpSTANDARD);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CDeviceDExtStd_Reset(CDeviceDExtStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Record Container(s)*/
        CDeviceDExtStd_DeleteDeviceContainer(pObject);

        /*Initialize the Object*/
        if(bInit)
        {
            CDeviceDExtStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Initializes the container. Deletes any existing items in the container. The argument
Size will used as the max size limit of the container. A size of zero will be used 
to signify that there is no max size limit.
**********************************************************************************/
boolean CDeviceDExtStd_InitDeviceContainer(CDeviceDExtStd *pObject, uint32 Size)
{
    boolean Result = FALSE;

    if(pObject != NULL)
    {
        /*Delete existing container and
        initialize container's members*/
        Result = CDeviceDExtStd_DeleteDeviceContainer(pObject);

        if((Result) && (Size))
        {
            /*Allocate memory for the container*/
            pObject->m_DeviceContainer = (uint8*)SYS_REALLOC(pObject->m_DeviceContainer, Size * sizeof(uint8));

            if(pObject->m_DeviceContainer != NULL)
                pObject->m_DeviceContainerMaxSize = Size * sizeof(uint8); /*Size in bytes*/

            pObject->bDeviceContainerMaxSize = TRUE;
        }
    }

    return Result;
}
/*********************************************************************************
Appends an item to the containter. If the max size is specified, then pBuffer 
will be appended only if it doesn't exceed the max size. If no max size is 
specified, then the pBuffer is appended without limit checks. NumberElements
is used to specify number of elements that are in pBuffer.
*********************************************************************************/
boolean CDeviceDExtStd_AppendDeviceContainer(CDeviceDExtStd *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements)
{
    boolean Result = FALSE;

    if((pObject != NULL) && (pBuffer != NULL) &&
       (Size > 0) && (NumberElements > 0))
    {
        if(pObject->bDeviceContainerMaxSize)
        {
            /*Verify that the Size + Current Size is within the max size limit*/
            if (Size + pObject->m_DeviceContainerSize <= pObject->m_DeviceContainerMaxSize)
            {
                /*Copy pBuffer*/
                memcpy(&pObject->m_DeviceContainer[pObject->m_DeviceContainerSize], pBuffer, Size);

                /*Calculate new Size*/
                pObject->m_DeviceContainerSize = pObject->m_DeviceContainerSize + Size;

                /*Increment number of elements*/
                pObject->m_DeviceContainerElements = pObject->m_DeviceContainerElements + NumberElements;

                Result = TRUE;
            }
        }
        /*Append pBuffer without restrictions*/
        else
        {
            pObject->m_DeviceContainer = (uint8*)SYS_REALLOC(pObject->m_DeviceContainer, pObject->m_DeviceContainerSize + Size);

            if(pObject->m_DeviceContainer != NULL)
            {
                /*Copy pBuffer*/
                memcpy(&pObject->m_DeviceContainer[pObject->m_DeviceContainerSize], pBuffer, Size);

                /*Calculate Size*/
                pObject->m_DeviceContainerSize += Size;

                /*Increment number of elements*/
                pObject->m_DeviceContainerElements = pObject->m_DeviceContainerElements + NumberElements;

                Result = TRUE;
            }
        }
    }

    return Result;
}
/*********************************************************************************
Free existing container and initialize to NULL. Initializes container's members.
*********************************************************************************/
boolean CDeviceDExtStd_DeleteDeviceContainer(CDeviceDExtStd *pObject)
{
    boolean Result = FALSE;

    if(pObject != NULL)
    {
        SYS_FREE(pObject->m_DeviceContainer);
        pObject->m_DeviceContainer = NULL;
        pObject->m_DeviceContainerMaxSize = 0;
        pObject->m_DeviceContainerSize = 0;
        pObject->m_DeviceContainerElements = 0;
        pObject->bDeviceContainerMaxSize = FALSE;

        Result = TRUE;
    }

    return Result;
}
/*********************************************************************************
Return pointer to serialized object at Index
*********************************************************************************/
uint8* CDeviceDExtStd_GetDeviceContainerAt(CDeviceDExtStd *pObject, uint16 Index, uint32 *pSize)
{
    if((pObject != NULL) && (pSize != NULL))
    {
        if((pObject->m_DeviceContainer != NULL) && (Index <= pObject->m_DeviceContainerElements))
        {
            uint8  pTempSize = 0;
            uint8* pBuffer = pObject->m_DeviceContainer;
            unsigned int i = 0;

            for(i = 0; i < pObject->m_DeviceContainerElements; i++)
            {
                /*Get size of serialized object*/
                *pSize = MOIBSerialSize(pBuffer, &pTempSize);

                if(i == Index)
                    return pBuffer;
                else
                   /*Increment pBuffer*/
                   pBuffer += *pSize;
            }
        }
    }

        return NULL;
}
/*********************************************************************************
Return pointer to the container
*********************************************************************************/
uint8* CDeviceDExtStd_GetDeviceContainer(CDeviceDExtStd *pObject, uint32 *pSize)
{
    if((pObject != NULL) && (pSize != NULL))
    {
        if(pObject->m_DeviceContainer != NULL)
        {
            *pSize = pObject->m_DeviceContainerSize;
            return pObject->m_DeviceContainer;
        }
    }

    return NULL;
}
/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CDeviceDExtStd_SizeAll(const CDeviceDExtStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CDEVDXTSTD_STATIC_DATA_SIZE;        /*Static data size*/

        /*m_DeviceContainerElements*/
        Size += sizeof(uint16);

        /*Container Buffer*/
        Size += pObject->m_DeviceContainerSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CDEVDXTSTD_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CDeviceDExtStd object into the buffer passed in.
*********************************************************************************/
boolean CDeviceDExtStd_Serialize(const CDeviceDExtStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        uint32 PayloadSize = CDeviceDExtStd_SizeAll(pObject) - CDEVDXTSTD_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CDEVDXTSTD_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CDEVDXTSTD_STATIC_DATA_SIZE);

        /* Serialize the m_DeviceContainer */
        WriteInt16(&pTemp, pObject->m_DeviceContainerElements);
        if (pObject->m_DeviceContainerElements > 0)
        {
            memcpy(pTemp, pObject->m_DeviceContainer, pObject->m_DeviceContainerSize);
            pTemp += pObject->m_DeviceContainerSize;
        }

        /* Set the CRC */
        CRCSize = CDeviceDExtStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CDeviceDExtStd object passed in.
*********************************************************************************/
boolean CDeviceDExtStd_Deserialize(CDeviceDExtStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CDEVDXTSTD_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CDeviceDExtStd_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((CDEVDXTSTD_VERSION_STATUS(CDEVDXTSTD_DeviceContainer, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            uint16 TempElements = 0;
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_DeviceContainerElements */
                                TempElements = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                if (TempElements > 0)
                                {
                                    uint8 pSize = 0;
                                    uint8* pBuffer = NULL; 
                                    uint32 TempSize = 0;
                                    unsigned i = 0;

                                    pBuffer = pTemp;

                                    /* Calculate the m_DeviceContainer size */
                                    for(i = 0; i < TempElements; i++)
                                    {
                                        /*Extract the serialized object's size*/
                                        TempSize = MOIBSerialSize(pBuffer, &pSize);

                                        /*Increment pBuffer*/
                                        pBuffer += TempSize;

                                        /*Increment the max size*/
                                        pObject->m_DeviceContainerMaxSize += TempSize;
                                    }

                                    if(ElementsUsed > pObject->m_DeviceContainerMaxSize)
                                    {
                                        /*Initialize the container with new max size*/
                                        if(CDeviceDExtStd_InitDeviceContainer(pObject, pObject->m_DeviceContainerMaxSize))
                                        {
                                            /*Append entire container*/
                                            if(CDeviceDExtStd_AppendDeviceContainer(pObject, pTemp, pObject->m_DeviceContainerMaxSize, TempElements))
                                            {
                                                pTemp += pObject->m_DeviceContainerMaxSize;
                                                ElementsUsed = ElementsUsed - pObject->m_DeviceContainerMaxSize;
                                                bResult = TRUE;
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    /*The record member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CDeviceDExtStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

