/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrEStd.c                                                        //
'**  '// Version        :   1.05                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CErrEStd.h"

const char * const CErrEStd_TypStackErrorTbl[CERR_MAX]={
    "No Error",
    "Invalid Family",
    "Invalid Genus",
    "Invalid Species",
    "Object ID Mismatch",
    "CRC Mismatch",
    "Invalid Entry",
    "Duplicate entry"
};

const char * const CErrEStd_TypProcErrorTbl[CERR_PROC_MAX]={
    "No Error",
    "Unimplemented",
    "Unsupported",
    "No memory",
    "No parameter",
    "Invalid parameter",
    "Range error",
    "No object",
    "Deserialization",
    "Serialization",
    "Context error",
    "Item does not exist"
};

#define CERR_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CErrEStd_TypVersionsTbl, \
                      CERR_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CErrEStd_TypVersionsTbl[CERR_MEMBER_MAX] = {
    100, 105, /*CERRESTD_ErrClassID*/
    100, 105, /*CERRESTD_ErrorCode*/
    100, 105, /*CERRESTD_Description*/
    100, 105, /*CERRESTD_Data*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CErrEStd_Init(CErrEStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CErrEStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmERROR, GnERROR, CERR_SpERRNONE);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CErrEStd_Reset(CErrEStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Dynamic members*/
        SYS_FREE(pObject->m_Data);
        pObject->m_Data = NULL;
        pObject->m_DataSize = 0;


        /*Initialize the Object*/
        if(bInit)
        {
            CErrEStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CErrEStd_SizeAll(const CErrEStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CERR_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16) + pObject->m_DataSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CERR_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CErrEStd object into the buffer passed in.
*********************************************************************************/
boolean CErrEStd_Serialize(const CErrEStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CErrEStd_SizeAll(pObject) - CERR_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CERR_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CERR_STATIC_DATA_SIZE);

        /* Set the m_ErrClassID */
        WriteInt32(&pTemp, (uint32)pObject->m_ErrClassID);

        /* Set the m_ErrorCode */
        WriteInt16(&pTemp, (uint16)pObject->m_ErrorCode);

        /* Set the m_Description */
        for(index = 0; index < sizeof(pObject->m_Description)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_Description[index]); 
        }

        /* Set the m_DataSize */
        WriteInt16(&pTemp, pObject->m_DataSize);

        /* Set the m_Data */
        for(index = 0; index < (pObject->m_DataSize/sizeof(uint8)); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_Data[index]); 
        }

        /* Set the CRC */
        CRCSize = CErrEStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CErrEStd object passed in.
*********************************************************************************/
boolean CErrEStd_Deserialize(CErrEStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;
            uint32  index;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CERR_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CErrEStd_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CERR_VERSION_STATUS(CERR_ErrClassID, pObject->SrcVersion)))
                        {
                            /* Get the m_ErrClassID */
                            pObject->m_ErrClassID = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if((StructSize) &&
                           (CERR_VERSION_STATUS(CERR_ErrorCode, pObject->SrcVersion)))
                        {
                            /* Get the m_ErrorCode */
                            pObject->m_ErrorCode = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if((StructSize) &&
                           (CERR_VERSION_STATUS(CERR_Description, pObject->SrcVersion)))
                        {
                            /* Get the m_Description */
                            for(index = 0; index < sizeof(pObject->m_Description)/sizeof(ansichar); index++)
                            {
                                pObject->m_Description[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_Description);
                            StructSize -= sizeof(pObject->m_Description);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                        if((CERR_VERSION_STATUS(CERR_Data, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_DataSize */
                                pObject->m_DataSize = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                /* Get the m_Data */
                                if (pObject->m_DataSize > 0)
                                {
                                    if(ElementsUsed > pObject->m_DataSize)
                                    {
                                        pObject->m_Data = (uint8*)SYS_REALLOC(pObject->m_Data, pObject->m_DataSize);
                                        if(pObject->m_Data != NULL)
                                        {
                                            for(index = 0; index < pObject->m_DataSize/sizeof(uint8); index++)
                                            {
                                                pObject->m_Data[index] = ReadInt8(&pTemp);
                                            }
                                            ElementsUsed = ElementsUsed - pObject->m_DataSize;
                                            bResult = TRUE;
                                        }
                                    }
                                }
                                else
                                {
                                    /*The dynamic member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CErrEStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

