/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashPMsgArg.c                                                   //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CFlashPMsgArg.h"

#define CFLSPMSA_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CFlashPMsgArg_TypVersionsTbl, \
                      CFLSPMSA_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CFlashPMsgArg_TypVersionsTbl[CFLSPMSA_MEMBER_MAX] = {
    100, 200, /*CFLASHPMSGARG_IOParameterA*/
    100, 200, /*CFLASHPMSGARG_IOParameterB*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CFlashPMsgArg_Init(CFlashPMsgArg *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CFlashPMsgArg));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmFLASH, GnPARAMETER, CFLSPMSA_SpMSG_ARGUMENTS);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CFlashPMsgArg_Reset(CFlashPMsgArg *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Initialize the Object*/
        if(bInit)
        {
            CFlashPMsgArg_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CFlashPMsgArg_SizeAll(const CFlashPMsgArg *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CFLSPMSA_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16);            /* CRC bytes */

        return CFLSPMSA_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CFlashPMsgArg object into the buffer passed in.
*********************************************************************************/
boolean CFlashPMsgArg_Serialize(const CFlashPMsgArg *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        uint32 PayloadSize = CFlashPMsgArg_SizeAll(pObject) - CFLSPMSA_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CFLSPMSA_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CFLSPMSA_STATIC_DATA_SIZE);

        /* Set the m_IOParameterA */
        WriteInt32(&pTemp, (uint32)pObject->m_IOParameterA);

        /* Set the m_IOParameterB */
        WriteInt32(&pTemp, (uint32)pObject->m_IOParameterB);

        /* Set the CRC */
        CRCSize = CFlashPMsgArg_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CFlashPMsgArg object passed in.
*********************************************************************************/
boolean CFlashPMsgArg_Deserialize(CFlashPMsgArg *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CFLSPMSA_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CFlashPMsgArg_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CFLSPMSA_VERSION_STATUS(CFLSPMSA_IOParameterA, pObject->SrcVersion)))
                        {
                            /* Get the m_IOParameterA */
                            pObject->m_IOParameterA = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if((StructSize) &&
                           (CFLSPMSA_VERSION_STATUS(CFLSPMSA_IOParameterB, pObject->SrcVersion)))
                        {
                            /* Get the m_IOParameterB */
                            pObject->m_IOParameterB = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CFlashPMsgArg_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

