/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashPMsgArg.h                                                   //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CFLASHPMSGARG_H)
    #define  CFLASHPMSGARG_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CFLSPMSAtypMODEID {
        CFLSPMSA_ModeID_NONE = 0, /*None*/
        CFLSPMSA_ModeID_BOOTLOADER = 1, /*Indicates that the upgrade will occur in the Bootloader mode*/
        CFLSPMSA_ModeID_APPLICATION = 2, /*Indicates that the upgrade will occur in the Application mode*/
        CFLSPMSA_ModeID_MAX
    } CFLSPMSA_MODEID;

    typedef  enum CFLSPMSAtypIMAGEID {
        CFLSPMSA_ImageID_NONE = 0, /*None*/
        CFLSPMSA_ImageID_BOOTLOADER = 1, /*Indicates that the bootloader is being upgraded*/
        CFLSPMSA_ImageID_APPLICATION = 2, /*Indicates that the application is being upgraded*/
        CFLSPMSA_ImageID_MAX
    } CFLSPMSA_IMAGEID;

    typedef  enum CFLSPMSAtypSPECIES {
        CFLSPMSA_SpMSG_ARGUMENTS = 1, /*Default species. Generic Message Argument.*/
        CFLSPMSA_SpMODE = 2, /*IOParameterA is used for the enumerated ModeID. IOParameterB is reserved.*/
        CFLSPMSA_SpDESCRIPTION = 3, /*IOParameterA is used for the ImageID. IOParameterB is used for the ImageSize(total byte size of the image).*/
        CFLSPMSA_SpPREP_CONFIGURATION = 4, /*IOParameterA is used for PreparationWaitTime (a value that indicates the expected wait time that it takes to prepare the memory). IOParameterB is reserved.*/
        CFLSPMSA_SpPROG_CONFIGURATION = 5, /*IOParameterA is used for ProgramWaitTime (a value that indicates the expected wait time that it takes to program the memory).  IOParameterB is used for ChunkSize (a value that indicates the maxmimum chunk size that the device can support).*/
        CFLSPMSA_SpMAX
    } CFLSPMSA_SPECIES;

    /*CFlashPMsgArg Member's Version Enumerations*/
    typedef  enum CFLSPMSAtypVERSIONS {
        CFLSPMSA_IOParameterA,
        CFLSPMSA_IOParameterB,
        CFLSPMSA_MEMBER_MAX
    } CFLSPMSA_VERSIONS;


/*The following definition is the version.*/
#define CFLSPMSA_OBJECT_VERSION 200

#define CFLSPMSA_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CFLSPMSA_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 2 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CFlashPMsgArg
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_IOParameterA; /* Generic parameter used for ImageID/ModeID/PreparationWaitTime(msec)/ProgramWaitTime(msec) */
    uint32             m_IOParameterB; /* Generic parameter used for ImageSize/ChunkSize */

}CFlashPMsgArg;

void    CFlashPMsgArg_Init(CFlashPMsgArg *pObject);
void    CFlashPMsgArg_Reset(CFlashPMsgArg *pObject, boolean bResetAll, boolean bInit);
uint32  CFlashPMsgArg_SizeAll(const CFlashPMsgArg *pObject);
boolean CFlashPMsgArg_Deserialize(CFlashPMsgArg *pObject, uint8 *pBuf);
boolean CFlashPMsgArg_Serialize(const CFlashPMsgArg *pObject, uint8 *pBuf);

#endif /* #if !defined(CFLASHPMSGARG_H) */

