/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRNDZDStd.h                                                       //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CRNDZDSTD_H)
    #define  CRNDZDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*DeviceGUID declaration.*/
extern const uint8 DeviceGUID[16];

/*DDSVersion declaration.*/
extern const uint16 DDSVersion;
/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRDZDSTDtypSPECIES {
        CRDZDSTD_SpSTANDARD = 0, 
        CRDZDSTD_SpMAX
    } CRDZDSTD_SPECIES;

    /*CRNDZDStd Member's Version Enumerations*/
    typedef  enum CRDZDSTDtypVERSIONS {
        CRDZDSTD_DeviceGUID,
        CRDZDSTD_DDSVersion,
        CRDZDSTD_Data,
        CRDZDSTD_MEMBER_MAX
    } CRDZDSTD_VERSIONS;


/*The following definition is the version.*/
#define CRDZDSTD_OBJECT_VERSION 101

#define CRDZDSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CRDZDSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 16 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CRNDZDStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint8              m_DeviceGUID[16]; /* A value that represents the DDS GUID. */
    uint16             m_DDSVersion; /* A value that represents the DDS version. */

    /*Dynamic Data*/
    uint8              *m_Data; /*Reserved. A generic array to provide additional information.*/
    uint16    m_DataSize;

}CRNDZDStd;

void    CRNDZDStd_Init(CRNDZDStd *pObject);
void    CRNDZDStd_Reset(CRNDZDStd *pObject, boolean bResetAll, boolean bInit);
uint32  CRNDZDStd_SizeAll(const CRNDZDStd *pObject);
boolean CRNDZDStd_Deserialize(CRNDZDStd *pObject, uint8 *pBuf);
boolean CRNDZDStd_Serialize(const CRNDZDStd *pObject, uint8 *pBuf);

#endif /* #if !defined(CRNDZDSTD_H) */

