/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRecordDStd.c                                                     //
'**  '// Version        :   1.02                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CRecordDStd.h"

#define CRCDDSTD_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CRecordDStd_TypVersionsTbl, \
                      CRCDDSTD_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CRecordDStd_TypVersionsTbl[CRCDDSTD_MEMBER_MAX] = {
    100, 102, /*CRECORDDSTD_RecordCount*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CRecordDStd_Init(CRecordDStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CRecordDStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmRECORD, GnDATA, CRCDDSTD_SpSTANDARD);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CRecordDStd_Reset(CRecordDStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Initialize the Object*/
        if(bInit)
        {
            CRecordDStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CRecordDStd_SizeAll(const CRecordDStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CRCDDSTD_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16);            /* CRC bytes */

        return CRCDDSTD_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CRecordDStd object into the buffer passed in.
*********************************************************************************/
boolean CRecordDStd_Serialize(const CRecordDStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        uint32 PayloadSize = CRecordDStd_SizeAll(pObject) - CRCDDSTD_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CRCDDSTD_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CRCDDSTD_STATIC_DATA_SIZE);

        /* Set the m_RecordCount */
        WriteInt32(&pTemp, (uint32)pObject->m_RecordCount);

        /* Set the CRC */
        CRCSize = CRecordDStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CRecordDStd object passed in.
*********************************************************************************/
boolean CRecordDStd_Deserialize(CRecordDStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CRCDDSTD_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CRecordDStd_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CRCDDSTD_VERSION_STATUS(CRCDDSTD_RecordCount, pObject->SrcVersion)))
                        {
                            /* Get the m_RecordCount */
                            pObject->m_RecordCount = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CRecordDStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

