/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRecordDStd.h                                                     //
'**  '// Version        :   1.02                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CRECORDDSTD_H)
    #define  CRECORDDSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CRCDDSTDtypSPECIES {
        CRCDDSTD_SpSTANDARD = 0, 
        CRCDDSTD_SpNIBP, 
        CRCDDSTD_SpTEMPERATURE, 
        CRCDDSTD_SpSPO2, 
        CRCDDSTD_SpHEIGHT, 
        CRCDDSTD_SpWEIGHT, 
        CRCDDSTD_SpCO2, 
        CRCDDSTD_SpRESTING_ECG, 
        CRCDDSTD_SpSTRESS_ECG, 
        CRCDDSTD_SpSPIROMETRY, 
        CRCDDSTD_SpTEMPERATURE_PROBE, 
        CRCDDSTD_SpBATTERY, 
        CRCDDSTD_SpHOURS, 
        CRCDDSTD_SpTEMPERATURE_DOCK, /*Indicates the count of temp modules docked*/
        CRCDDSTD_SpMAX
    } CRCDDSTD_SPECIES;

    /*CRecordDStd Member's Version Enumerations*/
    typedef  enum CRCDDSTDtypVERSIONS {
        CRCDDSTD_RecordCount,
        CRCDDSTD_MEMBER_MAX
    } CRCDDSTD_VERSIONS;


/*The following definition is the version.*/
#define CRCDDSTD_OBJECT_VERSION 102

#define CRCDDSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CRCDDSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CRecordDStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_RecordCount; /* Number of recorded procedures on the unit (or hours of operation) since it was manufactured */

}CRecordDStd;

void    CRecordDStd_Init(CRecordDStd *pObject);
void    CRecordDStd_Reset(CRecordDStd *pObject, boolean bResetAll, boolean bInit);
uint32  CRecordDStd_SizeAll(const CRecordDStd *pObject);
boolean CRecordDStd_Deserialize(CRecordDStd *pObject, uint8 *pBuf);
boolean CRecordDStd_Serialize(const CRecordDStd *pObject, uint8 *pBuf);

#endif /* #if !defined(CRECORDDSTD_H) */

