/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CTempDData.c                                                      //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CTempDData.h"

#define CTMPDDTA_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CTempDData_TypVersionsTbl, \
                      CTMPDDTA_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CTempDData_TypVersionsTbl[CTMPDDTA_MEMBER_MAX] = {
    200, 200, /*CTEMPDDATA_STime*/
    200, 200, /*CTEMPDDATA_Status*/
    200, 200, /*CTEMPDDATA_ExtStatus*/
    200, 200, /*CTEMPDDATA_Source*/
    200, 200, /*CTEMPDDATA_Mode*/
    200, 200, /*CTEMPDDATA_Method*/
    200, 200, /*CTEMPDDATA_Temperature*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CTempDData_Init(CTempDData *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CTempDData));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmTEMP, GnDATA, CTMPDDTA_SpDATA);

        /*Initialize sub-objects*/
        CNumDFloat_Init(&pObject->Temperature);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CTempDData_Reset(CTempDData *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Objects to only free allocated memory*/
        if(bResetAll)
        {
            CNumDFloat_Reset(&pObject->Temperature, TRUE, FALSE);
        }

        /*Initialize the Object*/
        if(bInit)
        {
            CTempDData_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CTempDData_SizeAll(const CTempDData *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CTMPDDTA_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint32) + CNumDFloat_SizeAll(&pObject->Temperature);

        Size += sizeof(uint16);            /* CRC bytes */

        return CTMPDDTA_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CTempDData object into the buffer passed in.
*********************************************************************************/
boolean CTempDData_Serialize(const CTempDData *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        uint32 ObjectSize;
        uint8  *Buffer = NULL;
        uint32 PayloadSize = CTempDData_SizeAll(pObject) - CTMPDDTA_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CTMPDDTA_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CTMPDDTA_STATIC_DATA_SIZE);

        /* Set the m_STime */
        Put_MOIBTIME(&pTemp, pObject->m_STime);

        /* Set the m_Status */
        WriteInt16(&pTemp, (uint16)pObject->m_Status);

        /* Set the m_ExtStatus */
        WriteInt16(&pTemp, (uint16)pObject->m_ExtStatus);

        /* Set the m_Source */
        WriteInt16(&pTemp, (uint16)pObject->m_Source);

        /* Set the m_Mode */
        WriteInt8(&pTemp, (uint8)pObject->m_Mode);

        /* Set the m_Method */
        WriteInt8(&pTemp, (uint8)pObject->m_Method);

        /*Serialize Temperature*/
        ObjectSize = CNumDFloat_SizeAll(&pObject->Temperature);
        WriteInt32(&pTemp, ObjectSize);
        if(ObjectSize > 0)
        {
            Buffer = (uint8*)SYS_REALLOC(Buffer, ObjectSize);
        }
        if(Buffer != NULL)
        {
            CNumDFloat_Serialize(&pObject->Temperature, Buffer);
            memcpy(pTemp, Buffer, ObjectSize);
            pTemp += ObjectSize;
        }

        SYS_FREE(Buffer);
        Buffer = NULL;

        /* Set the CRC */
        CRCSize = CTempDData_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CTempDData object passed in.
*********************************************************************************/
boolean CTempDData_Deserialize(CTempDData *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint32  ObjectSize;
            uint8   *Buffer = NULL;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CTMPDDTA_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CTempDData_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CTMPDDTA_VERSION_STATUS(CTMPDDTA_STime, pObject->SrcVersion)))
                        {
                            /* Get the m_STime */
                            pObject->m_STime = Get_MOIBTIME(&pTemp);
                            ElementsUsed -= MOIB_TIME_SIZE;
                            StructSize -= MOIB_TIME_SIZE;
                        }
                        if((StructSize) &&
                           (CTMPDDTA_VERSION_STATUS(CTMPDDTA_Status, pObject->SrcVersion)))
                        {
                            /* Get the m_Status */
                            pObject->m_Status = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if((StructSize) &&
                           (CTMPDDTA_VERSION_STATUS(CTMPDDTA_ExtStatus, pObject->SrcVersion)))
                        {
                            /* Get the m_ExtStatus */
                            pObject->m_ExtStatus = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if((StructSize) &&
                           (CTMPDDTA_VERSION_STATUS(CTMPDDTA_Source, pObject->SrcVersion)))
                        {
                            /* Get the m_Source */
                            pObject->m_Source = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if((StructSize) &&
                           (CTMPDDTA_VERSION_STATUS(CTMPDDTA_Mode, pObject->SrcVersion)))
                        {
                            /* Get the m_Mode */
                            pObject->m_Mode = ReadInt8(&pTemp);
                            ElementsUsed -= sizeof(uint8);
                            StructSize -= sizeof(uint8);
                        }
                        if((StructSize) &&
                           (CTMPDDTA_VERSION_STATUS(CTMPDDTA_Method, pObject->SrcVersion)))
                        {
                            /* Get the m_Method */
                            pObject->m_Method = ReadInt8(&pTemp);
                            ElementsUsed -= sizeof(uint8);
                            StructSize -= sizeof(uint8);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                        if((CTMPDDTA_VERSION_STATUS(CTMPDDTA_Temperature, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint32))
                            {
                                /*Dequeue the Temperature object*/
                                ObjectSize = ReadInt32(&pTemp);
                                ElementsUsed -= sizeof(uint32);

                                if((ElementsUsed > ObjectSize) && (ObjectSize > 0))
                                {
                                    Buffer = (uint8*)SYS_REALLOC(Buffer, ObjectSize);
                                    if(Buffer != NULL)
                                    {
                                        memcpy(Buffer, pTemp, ObjectSize);
                                        bResult = CNumDFloat_Deserialize(&pObject->Temperature, Buffer);
                                        pTemp += ObjectSize;
                                        ElementsUsed -= ObjectSize;
                                    }
                                }
                            }
                        }

                        SYS_FREE(Buffer);
                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CTempDData_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

