/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CTempDData.h                                                      //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CTEMPDDATA_H)
    #define  CTEMPDDATA_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"


#include "CNumDFloat.h"
/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CTMPDDTAtypSTATUS {
        CTMPDDTA_Status_DATA_NOT_AVAIL = 0, 
        CTMPDDTA_Status_DATA_COMPLETE, 
        CTMPDDTA_Status_DATA_FAILURE, 
        CTMPDDTA_Status_DATA_EXCEPTION, 
        CTMPDDTA_Status_DATA_PROCESSING, 
        CTMPDDTA_Status_MAX
    } CTMPDDTA_STATUS;

    typedef  enum CTMPDDTAtypEXTSTATUS {
        CTMPDDTA_ExtStatus_NONE = 0, 
        CTMPDDTA_ExtStatus_FINAL_POSITION, 
        CTMPDDTA_ExtStatus_FINAL_OVER_TEMP, 
        CTMPDDTA_ExtStatus_FINAL_OVER_TEMP_POSITION, 
        CTMPDDTA_ExtStatus_FINAL_UNDER_TEMP, 
        CTMPDDTA_ExtStatus_FINAL_UNDER_TEMP_POSITION, 
        CTMPDDTA_ExtStatus_MONITOR_POSITION, 
        CTMPDDTA_ExtStatus_MONITOR_OVER_TEMP, 
        CTMPDDTA_ExtStatus_MONITOR_OVER_TEMP_POSITION, 
        CTMPDDTA_ExtStatus_MONITOR_UNDER_TEMP, 
        CTMPDDTA_ExtStatus_MONITOR_UNDER_TEMP_POSITION, 
        CTMPDDTA_ExtStatus_MAX
    } CTMPDDTA_EXTSTATUS;

    typedef  enum CTMPDDTAtypSOURCE {
        CTMPDDTA_Source_NONE = 0, 
        CTMPDDTA_Source_UNKNOWN, 
        CTMPDDTA_Source_SURETEMP_SW = 10, 
        CTMPDDTA_Source_SURETEMP, 
        CTMPDDTA_Source_SURETEMP_PLUS, 
        CTMPDDTA_Source_BRAUN_PRO4000, 
        CTMPDDTA_Source_MAX
    } CTMPDDTA_SOURCE;

    typedef  enum CTMPDDTAtypMODE {
        CTMPDDTA_Mode_NONE = 0, 
        CTMPDDTA_Mode_UNKNOWN, 
        CTMPDDTA_Mode_ORAL = 10, 
        CTMPDDTA_Mode_RECTAL, 
        CTMPDDTA_Mode_PED_AXIL, 
        CTMPDDTA_Mode_CAL_KEY, 
        CTMPDDTA_Mode_ADULT_AXIL, 
        CTMPDDTA_Mode_TYMPANIC, 
        CTMPDDTA_Mode_MAX
    } CTMPDDTA_MODE;

    typedef  enum CTMPDDTAtypMETHOD {
        CTMPDDTA_Method_NONE = 0, 
        CTMPDDTA_Method_UNKNOWN, 
        CTMPDDTA_Method_MANUAL, 
        CTMPDDTA_Method_DEVICE, 
        CTMPDDTA_Method_REMOTE, 
        CTMPDDTA_Method_PREDICT = 10, 
        CTMPDDTA_Method_MONITOR, 
        CTMPDDTA_Method_IR, 
        CTMPDDTA_Method_MAX
    } CTMPDDTA_METHOD;

    typedef  enum CTMPDDTAtypSPECIES {
        CTMPDDTA_SpDATA = 1, 
        CTMPDDTA_SpMAX
    } CTMPDDTA_SPECIES;

    /*CTempDData Member's Version Enumerations*/
    typedef  enum CTMPDDTAtypVERSIONS {
        CTMPDDTA_STime,
        CTMPDDTA_Status,
        CTMPDDTA_ExtStatus,
        CTMPDDTA_Source,
        CTMPDDTA_Mode,
        CTMPDDTA_Method,
        CTMPDDTA_Temperature,
        CTMPDDTA_MEMBER_MAX
    } CTMPDDTA_VERSIONS;


/*The following definition is the version.*/
#define CTMPDDTA_OBJECT_VERSION 200

#define CTMPDDTA_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CTMPDDTA_STATIC_DATA_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 2 *(sizeof(uint8))   + 3 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CTempDData
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    MOIB_TIME          m_STime; /* Time reading was taken */
    uint16             m_Status; /* DATA_NOT_AVAIL, DATA_COMPLETE, etc */
    uint16             m_ExtStatus; /* Extended status/error code */
    uint16             m_Source; /* Source of data */
    uint8              m_Mode; /* Mode of operation */
    uint8              m_Method; /* Method used */

    /*Object Instances*/
    CNumDFloat         Temperature; /*Temperature {in deg K}*/

}CTempDData;

void    CTempDData_Init(CTempDData *pObject);
void    CTempDData_Reset(CTempDData *pObject, boolean bResetAll, boolean bInit);
uint32  CTempDData_SizeAll(const CTempDData *pObject);
boolean CTempDData_Deserialize(CTempDData *pObject, uint8 *pBuf);
boolean CTempDData_Serialize(const CTempDData *pObject, uint8 *pBuf);

#endif /* #if !defined(CTEMPDDATA_H) */

