/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFamilyEnum.h                                                     //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CFAMILYENUM_H)
    #define  CFAMILYENUM_H

    /* FmDEVICE Message Enumerations */
    typedef enum DEVICECCMDtypSPECIES{
        DEVICE_CCMD_SpWRITE_CONFIG,/*Requires a CDeviceCStd object or CDeviceCAudio object.*/
        DEVICE_CCMD_SpWRITE_DEVICEDESCRIPTION,/*Writes the CDeviceDStd object. ATE only. Requires a CDeviceDStd if a single object is written or a CDeviceDExtStd object containing 1 or more CDeviceDStd objects. The species of the CDeviceDStd objects should be set with the appropriate subsystem (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor ). A legacy messge formerly labeled as 'WRITE_DATA'*/
        DEVICE_CCMD_SpENABLE_DISPLAY,/*Display control. Toggles the display on/off with no message argument.*/
        DEVICE_CCMD_SpSTART_DISPLAY_TEST,/*Sets the device display. Requires a CDeviceCLCD that has the enumerated state of within LCD*/
        DEVICE_CCMD_SpRESET,/*Resets the device to use the current configuration settings.*/
        DEVICE_CCMD_SpPOWER,/*Sets the device power state. Requires a CDevPMsgArguments with the IOParameterA set to a PowerControl value. PowerControl should be published by the devices since different control variables may exist*/
        DEVICE_CCMD_SpBEEP,/*Sounds the device speakers. Requires a CDeviceCAudio.*/
        DEVICE_CCMD_SpSAVE_CONFIG,/*Save the current user configuration settings to non-volatile memory*/
        DEVICE_CCMD_SpRESTORE_CONFIG,/*Restore user configuration settings to their factory defaults*/
        DEVICE_CCMD_SpENABLE_AUTO_POWER_DOWN,/*Enable or disable device auto power down*/
        DEVICE_CCMD_SpSET_DISPLAY_CONTRAST,/*Sets display configuration for contrast. Requires a CDeviceCLCD.*/
        DEVICE_CCMD_SpSET_BACKLIGHT,/*Sets the display configuration for backlight level. Requires a CDeviceCLCD.*/
        DEVICE_CCMD_SpSTART_DIGITAL_TEST,/*Sets the Digital Output Lines. Requires a CDevPMsgArguments with IOParameterA set a value indicating the bits correlating to digital lines to signal. The bit-to-digital line representation is published by each subsystem.*/
        DEVICE_CCMD_SpSTOP_DISPLAY_TEST,/*Stops the active display test enabled by the START_DISPLAY_TEST command. Doesn't require an object in the payload.*/
        DEVICE_CCMD_SpSET_DEVICE_MODE,/*Sets the device mode. Requires a CDevPMsgArguments with IOParameterA set with the device mode enumeration.*/
        DEVICE_CCMD_SpSTART_PRINTER_TEST,/*Starts a printer test*/
        DEVICE_CCMD_SpSET_CALIBRATION,/*Sets the device calibration. Requires a CDeviceCCal object.*/
        DEVICE_CCMD_SpSET_DATE_TIME,/*Sets the CDeviceCTime Object*/
        DEVICE_CCMD_SpNEXT_PATIENT,/*Prepares the device for the next patient*/
        DEVICE_CCMD_SpMAX
    } DEVICE_CCMD_SPECIES;

    typedef enum DEVICECRSTtypSPECIES{
        DEVICE_CRST_SpGET_DEVICEDESCRIPTION,/*May contain a CDevPMsgArguments with the SpeciesSelector set to indicate what subsystem's CDeviceDStd object to retrieve (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor | SpALL = All subsytems).*/
        DEVICE_CRST_SpGET_CONFIG,/*Requires a CDevPMsgArguments with the SpeciesSelector set to indicate what configuration object to retrieve (SpeciesSelector: SpSTANDARD = CDeviceCStd | SpAUDIO = CDeviceCAudio | SpLCD = CDeviceCLCD) | SpINVENTORY = CDeviceCINVENTORY)*/
        DEVICE_CRST_SpGET_POST,/*Gets the POST status from the device.*/
        DEVICE_CRST_SpGET_DIGITAL_STATE,/*Gets the Digital Input State of the device.*/
        DEVICE_CRST_SpGET_DEVICE_MODE,/*Requests the current device mode from the device. No object required in payload.*/
        DEVICE_CRST_SpGET_DEVICE_INVENTORY,/*Requests the device inventory. No object required in payload.*/
        DEVICE_CRST_SpGET_CALIBRATION,/*Requests the current device calibration from the device. No object required in payload.*/
        DEVICE_CRST_SpGET_DATE_TIME,/*Gets the CDeviceCTime Object*/
        DEVICE_CRST_SpMAX
    } DEVICE_CRST_SPECIES;

    typedef enum DEVICECRSPtypSPECIES{
        DEVICE_CRSP_SpPUT_DEVICEDESCRIPTION,/*May contain a CDeviceDExtStd object containing 1 or more CDeviceDStd object or a single CDeviceDStd object. The CDeviceDStd objects must be set with the proper Species for the subsystem (SpeciesSelector: SpSTANDARD = FMD | SpHOST = Compute Engine | SpSENSOR = Sensor)*/
        DEVICE_CRSP_SpPUT_CONFIG,/*Requires a CDeviceCStd object or CDeviceCAudio object.*/
        DEVICE_CRSP_SpPUT_POST,/*Requires a CDevDPOST object.*/
        DEVICE_CRSP_SpPUT_DIGITAL_STATE,/*Returns the Gets the Digital Input State of device. Requires a CDevPMsgArguments with IOParameterA set a value indicating the bits correlating to digital lines to signal. The bit-to-digital line representation is published by each subsystem.*/
        DEVICE_CRSP_SpPUT_DEVICE_MODE,/*Returns the current device mode from the device. A CDevPMsgArguments object is required with IOParameterA set with the device mode enumeration.*/
        DEVICE_CRSP_SpPUT_DEVICE_INVENTORY,/*Returns the device inventory from the device. A CDeviceDInventory object is required.*/
        DEVICE_CRSP_SpPUT_CALIBRATION,/*Returns the current device calibration. A CDeviceCCal object is required.*/
        DEVICE_CRSP_SpPUT_DATE_TIME,/*Returns the current CDeviceCTime Object*/
        DEVICE_CRSP_SpMAX
    } DEVICE_CRSP_SPECIES;

    /* FmERROR Message Enumerations */
    typedef enum ERRORCCMDtypSPECIES{
        ERROR_CCMD_SpCLEAR_ERROR,/*Requires a CErrEStd object. Used to clear the error messages.*/
        ERROR_CCMD_SpMAX
    } ERROR_CCMD_SPECIES;

    typedef enum ERRORCRSTtypSPECIES{
        ERROR_CRST_SpGET_ERROR,/*Requires a CErrPGetError object*/
        ERROR_CRST_SpMAX
    } ERROR_CRST_SPECIES;

    typedef enum ERRORCRSPtypSPECIES{
        ERROR_CRSP_SpPUT_ERROR,/*Requires a CErrEStd object for the requested error.*/
        ERROR_CRSP_SpMAX
    } ERROR_CRSP_SPECIES;

    typedef enum ERRORCSStypSPECIES{
        ERROR_CSS_SpREPORT_ERROR,/*Requires a CErrEStd object. Requires a CErrDExtStd object containing a 1 or more CErrEStd objects for devices with container support. Used to push error messages during changes of state.*/
        ERROR_CSS_SpMAX
    } ERROR_CSS_SPECIES;

    /* FmMODULE Message Enumerations */
    typedef enum MODULECCMDtypSPECIES{
        MODULE_CCMD_SpWRITE_CONFIG,/*Legacy message.*/
        MODULE_CCMD_SpWRITE_MODULE_DESC,/*Requires a CModuleDStd object.*/
        MODULE_CCMD_SpMAX
    } MODULE_CCMD_SPECIES;

    typedef enum MODULECRSTtypSPECIES{
        MODULE_CRST_SpGET_MODULE_DESC,/*Requires a CModulePSelector object.*/
        MODULE_CRST_SpGET_CONFIG,
        MODULE_CRST_SpMAX
    } MODULE_CRST_SPECIES;

    typedef enum MODULECRSPtypSPECIES{
        MODULE_CRSP_SpPUT_MODULE_DESC,/*Requires a Record containing CModuleDExtStd objects.*/
        MODULE_CRSP_SpPUT_CONFIG,
        MODULE_CRSP_SpMAX
    } MODULE_CRSP_SPECIES;

    typedef enum MODULECEVNTtypSPECIES{
        MODULE_CEVNT_SpHW_MOD_CONNECT,/*Legacy message.*/
        MODULE_CEVNT_SpHW_MOD_DISCONNECT,/*Legacy message.*/
        MODULE_CEVNT_SpMAX
    } MODULE_CEVNT_SPECIES;

    /* FmNUMERIC Message Enumerations */
    typedef enum NUMERICCCMDtypSPECIES{
        NUMERIC_CCMD_SpCMD_START_ACQUIRE,/*Start sending numerics specified by CNumPSelector.*/
        NUMERIC_CCMD_SpCMD_STOP_ACQUIRE,/*Stop sending numerics specified by CNumPSelector.*/
        NUMERIC_CCMD_SpWRITE_CONFIG,/*Command to write the numeric configuration. Requires a CNumCStd object.*/
        NUMERIC_CCMD_SpMAX
    } NUMERIC_CCMD_SPECIES;

    typedef enum NUMERICCSTRtypSPECIES{
        NUMERIC_CSTR_SpSTREAM_NUMERIC,
        NUMERIC_CSTR_SpMAX
    } NUMERIC_CSTR_SPECIES;

    /* FmTEMP Message Enumerations */
    typedef enum TEMPCCMDtypSPECIES{
        TEMP_CCMD_SpWRITE_CONFIG,
        TEMP_CCMD_SpMSG_PUSH_ENABLE,/*Requires a CSTPPSelector*/
        TEMP_CCMD_SpMSG_SET_ALG,/*Requires a CSTPPSelector*/
        TEMP_CCMD_SpMSG_SET_MODE,/*Requires a CSTPPSelector*/
        TEMP_CCMD_SpRESET_DEVICE,
        TEMP_CCMD_SpSET_CALIBRATION,/*Requires CSTPCCal.*/
        TEMP_CCMD_SpSAVE_CALIBRATION,/**/
        TEMP_CCMD_SpLOAD_CALIBRATION,/**/
        TEMP_CCMD_SpRESTORE_DFLT_CALIBRATION,/**/
        TEMP_CCMD_SpSET_SETTINGS,/*Requires CSTPCStd*/
        TEMP_CCMD_SpSAVE_SETTINGS,
        TEMP_CCMD_SpLOAD_SETTINGS,
        TEMP_CCMD_SpRESTORE_DFLT_SETTINGS,
        TEMP_CCMD_SpSET_HARDWARE_STATE,/*Requires a CSTPDHState*/
        TEMP_CCMD_SpSET_TEST_LOCK,/*Requires a CSTPDLock*/
        TEMP_CCMD_SpMAX
    } TEMP_CCMD_SPECIES;

    typedef enum TEMPCRSTtypSPECIES{
        TEMP_CRST_SpGET_TEMP,/*May contain and optional selector object, CSTPPSelector to indicate what GnDATA object to retrieve (SpeciesSelector: SpSTANDARD =  CTempDStd | SpDATA = CTempDData). With no selector, the CTempDStd is returned.*/
        TEMP_CRST_SpGET_CONFIG,
        TEMP_CRST_SpGET_ENG_STATUS,
        TEMP_CRST_SpSTATUS,
        TEMP_CRST_SpGET_PROBE_INFO,
        TEMP_CRST_SpGET_CALIBRATION,/**/
        TEMP_CRST_SpGET_SETTINGS,
        TEMP_CRST_SpGET_HARDWARE_STATE,/*Requires a CSTPPSelector*/
        TEMP_CRST_SpGET_TEST_LOCK,/*Requires a CSTPPSelector*/
        TEMP_CRST_SpGET_RAW_DATA,
        TEMP_CRST_SpGET_SAMPLE,
        TEMP_CRST_SpMAX
    } TEMP_CRST_SPECIES;

    typedef enum TEMPCRSPtypSPECIES{
        TEMP_CRSP_SpPUT_TEMP,/*May contain a CTempDStd or CTempDData*/
        TEMP_CRSP_SpPUT_CONFIG,
        TEMP_CRSP_SpPUT_ENG_STATUS,/*Requires a CSTPTempDEng object*/
        TEMP_CRSP_SpPUT_STATUS,/*Requires a CSTPDStat*/
        TEMP_CRSP_SpPUT_PROBE_INFO,/*Requires a CSTPDProbe object*/
        TEMP_CRSP_SpPUT_CALIBRATION,/*Requires CSTPCCal.*/
        TEMP_CRSP_SpPUT_SETTINGS,/*Requires CSTPCStd*/
        TEMP_CRSP_SpPUT_HARDWARE_STATE,/*Requires a CSTPDHState*/
        TEMP_CRSP_SpPUT_TEST_LOCK,/*Requires a CSTPDLock*/
        TEMP_CRSP_SpPUT_RAW_DATA,/*Requires a CSTPDRData*/
        TEMP_CRSP_SpPUT_SAMPLE,/*Requires a CSTPDSample*/
        TEMP_CRSP_SpMAX
    } TEMP_CRSP_SPECIES;

    typedef enum TEMPCSStypSPECIES{
        TEMP_CSS_SpREPORT_TEMPERATURE,
        TEMP_CSS_SpMAX
    } TEMP_CSS_SPECIES;

    typedef enum TEMPCSTRtypSPECIES{
        TEMP_CSTR_SpREPORT_ENG_STATUS,
        TEMP_CSTR_SpREPORT_STATUS,
        TEMP_CSTR_SpREPORT_SAMPLE,
        TEMP_CSTR_SpMAX
    } TEMP_CSTR_SPECIES;

    /* FmRECORD Message Enumerations */
    typedef enum RECORDCCMDtypSPECIES{
        RECORD_CCMD_SpWRITE_CONFIG,/*Legacy message*/
        RECORD_CCMD_SpWRITE_RECORD_COUNT,/*Requires the CRecordDStd object or the CRecordDService object*/
        RECORD_CCMD_SpRESET_COUNTS,/*Reset the counts.*/
        RECORD_CCMD_SpMAX
    } RECORD_CCMD_SPECIES;

    typedef enum RECORDCRSTtypSPECIES{
        RECORD_CRST_SpGET_RECORD_COUNT,/*Requires the CRecordPSelector object*/
        RECORD_CRST_SpGET_CONFIG,/*Legacy message*/
        RECORD_CRST_SpMAX
    } RECORD_CRST_SPECIES;

    typedef enum RECORDCRSPtypSPECIES{
        RECORD_CRSP_SpPUT_RECORD_COUNT,/*Requires the CRecordDStd object or the CRecordDService object*/
        RECORD_CRSP_SpPUT_CONFIG,/*Legacy message*/
        RECORD_CRSP_SpMAX
    } RECORD_CRSP_SPECIES;

    typedef enum RECORDCSStypSPECIES{
        RECORD_CSS_SpREPORT_RECORD_COUNT,/*Requires the CRecordDStd object or the CRecordDService object*/
        RECORD_CSS_SpMAX
    } RECORD_CSS_SPECIES;

    /* FmDATATRANSFER Message Enumerations */
    typedef enum DATATRANSFERCCMDtypSPECIES{
        DATATRANSFER_CCMD_SpEXECUTE_DTT,/*Indicates Data Transmission Terminate. Requires a CDataTransferDExtStd object.*/
        DATATRANSFER_CCMD_SpMAX
    } DATATRANSFER_CCMD_SPECIES;

    typedef enum DATATRANSFERCRSTtypSPECIES{
        DATATRANSFER_CRST_SpGET_CONFIG,/*Used to propose Data Transmission and get the configuration object. Requires a CDataTransferCDesc object.*/
        DATATRANSFER_CRST_SpGET_DATA,/*Used to request data packets of a particular sequence. Requires a CDataTransferDExtStd object.*/
        DATATRANSFER_CRST_SpMAX
    } DATATRANSFER_CRST_SPECIES;

    typedef enum DATATRANSFERCRSPtypSPECIES{
        DATATRANSFER_CRSP_SpPUT_CONFIG,/*Used to Accept/Reject Data Transmission and return the configuration object. Requires a CDataTransferCDesc object.*/
        DATATRANSFER_CRSP_SpPUT_DATA,/*Used to return data packets of a particular sequence. Requires a CDataTransferDExtStd object.*/
        DATATRANSFER_CRSP_SpMAX
    } DATATRANSFER_CRSP_SPECIES;

    typedef enum DATATRANSFERCSStypSPECIES{
        DATATRANSFER_CSS_SpREPORT_DTR,/*Indicates Data Transmission Ready. Requires a CDataTransferDExtStd object.*/
        DATATRANSFER_CSS_SpREPORT_DTC,/*Indicates Data Transmission Complete. Requires a CDataTransferDExtStd object.*/
        DATATRANSFER_CSS_SpMAX
    } DATATRANSFER_CSS_SPECIES;

    /* FmFILESYS Message Enumerations */
    typedef enum FILESYSCCMDtypSPECIES{
        FILESYS_CCMD_SpWRITE_FILE,/*Requires a CFileSysDFil. Legacy message*/
        FILESYS_CCMD_SpMAX
    } FILESYS_CCMD_SPECIES;

    typedef enum FILESYSCRSTtypSPECIES{
        FILESYS_CRST_SpGET_FILE,/*Requires a CFileSysDFileDesc. Legacy message.*/
        FILESYS_CRST_SpGET_FILE_COUNT,/*A message to request the contents of a folder. Requires a CFileSysPSelector to request the count of a specific folder.*/
        FILESYS_CRST_SpGET_FILE_LIST,/*A message to request the contents of a folder. Requires a CFileSysPSelector to request the contents of a specific folder.*/
        FILESYS_CRST_SpMAX
    } FILESYS_CRST_SPECIES;

    typedef enum FILESYSCRSPtypSPECIES{
        FILESYS_CRSP_SpPUT_FILE,/*Requires a CFileSysDFil. Legacy message*/
        FILESYS_CRSP_SpPUT_FILE_COUNT,/*Requires a CWACPDNumeric object containing the folder/file count*/
        FILESYS_CRSP_SpPUT_FILE_LIST,/*Requires a CFileSysDExtStd containing 1 or more CFileSysDFileDesc objects*/
        FILESYS_CRSP_SpMAX
    } FILESYS_CRSP_SPECIES;

    /* FmFLASH Message Enumerations */
    typedef enum FLASHCCMDtypSPECIES{
        FLASH_CCMD_SpWRITE_SEGMENT,/*Sends a flash data segment. Requires a CFlashDChunk object.*/
        FLASH_CCMD_SpERASE_SECTOR,/*Legacy Message.*/
        FLASH_CCMD_SpENABLE_FLASH,/*Legacy Message.*/
        FLASH_CCMD_SpDISABLE_FLASH,/*Legacy Message.*/
        FLASH_CCMD_SpMAX
    } FLASH_CCMD_SPECIES;

    typedef enum FLASHCRSTtypSPECIES{
        FLASH_CRST_SpGET_CRC,/*Legacy Message.*/
        FLASH_CRST_SpGET_SEGMENT,/*Legacy Message.*/
        FLASH_CRST_SpGT_FLASH_CONFIG,/*Legacy Message.*/
        FLASH_CRST_SpGET_SECTOR_CONFIG,/*Legacy Message*/
        FLASH_CRST_SpGET_UPGRADE,/*Request for software upgrade. Requires a CFlashPMsgArg with IOParameterA containing the ImageID of the item being upgraded.*/
        FLASH_CRST_SpGET_FLASH_PREPARATION,/*Requests the device to prepare it's memory and describes the item to be flasehed. Requires a CFlashPMsgArg with IOParameterA containing the ModuleID and IOParameterB containing the ImageSize.*/
        FLASH_CRST_SpMAX
    } FLASH_CRST_SPECIES;

    typedef enum FLASHCRSPtypSPECIES{
        FLASH_CRSP_SpPUT_CRC,/*Legacy Message.*/
        FLASH_CRSP_SpPUT_SEGMENT,/*Legacy Message.*/
        FLASH_CRSP_SpPUT_FLASH_CONFIG,/*Legacy Message.*/
        FLASH_CRSP_SpPUT_SECTOR_CONFIG,/*Legacy Message.*/
        FLASH_CRSP_SpPUT_UPGRADE,/*Response for software upgrade. Requires a CFlashPMsgArg with IOParameterA containing the ModeID of the item device.*/
        FLASH_CRSP_SpPUT_FLASH_PREPARATION,/*Message that contains the preparation configuration. Requires a CFlashPMsgArg with IOParameterA containing the PreparationWaitTime.*/
        FLASH_CRSP_SpMAX
    } FLASH_CRSP_SPECIES;

    typedef enum FLASHCSStypSPECIES{
        FLASH_CSS_SpFLASH_READY,/*Message that indicates that all memory has been prepared and returns a program configuration. Requires a CFlashPMsgArg with IOParameterA containing the ProgramWaitTime and IOParameterB containing the ChunkSize.*/
        FLASH_CSS_SpFLASH_COMPLETE,/*Message to indicate that all data has been sent/received*/
        FLASH_CSS_SpMAX
    } FLASH_CSS_SPECIES;

#endif /* #if !defined(CFAMILYENUM_H) */

/*---------------------------------------------------*/
/* End of File */
