/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmCONNECTIONStub.c                                               //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CFmCONNECTIONStub.h"
extern boolean bConnected;

/*================================================================================
CFmCONNECTIONStub_RecvMsg : Handles messages for connections being established,
    terminated, or bypass setup.
================================================================================*/
boolean CFmCONNECTIONStub_RecvMsg(const char *pSourceID, uint8 Genus, uint8 Species, uint8* pBuffer)
{
    boolean Result = TRUE;
    TOUCH(pBuffer);
    TOUCH(pSourceID);

    switch(Genus)
    {
        case GnCOMMAND:
        {
            switch(Species)
            {
                case CONN_CMD_SpSHUTDOWN:
                {
					bConnected = FALSE;
					/*To Do: Connection has terminated disable any message streaming for any new connections.*/
                    break;
                }
                case CONN_CMD_SpSTARTBYPASS:
                {
                    break;
                }
                case CONN_CMD_SpENDBYPASS:
                {
                    break;
                }
                case CONN_CMD_SpBYPASSTERMINATED:
                {
                    break;
                }
                default:
                    break;
             }
        }
        case GnRESPONSE:
        {
            switch(Species)
            {
                case CONN_CRSP_SpPUTCONNLIST:
                {
                    break;
                }
                default:
                    break;
            }
        }
        case GnEVENT:
        {
            switch(Species)
            {
                case CONN_CEVNT_SpCONNECTED:
                {
                    break;
                }
                default:
                    break;
            }
        }
    }
    return Result;
}
