/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRNDZApp.h     :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(CRNDZAPP_H)
    #define  CRNDZAPP_H

/*State Machine to prevent a client from connecting */
/*without first going through the whole validation process*/
typedef enum RNDZValidationStates{
    RNDZ_VALIDATION_NONE=0,
    RNDZ_VALIDATION_START_RNDZ_RECVD,
    RNDZ_VALIDATION_KEY_EXCHANGE,
    RNDZ_VALIDATION_COMPLETE
}RNDZ_VALIDATION_TYPE;

typedef  enum RNDZCCMDtypSPECIES {
    RNDZ_CCMD_SpNONE = 0,
    RNDZ_CCMD_SpTERMINATE,
    RNDZ_CCMD_SpSTART_HOST_PROC,
    RNDZ_CCMD_SpSEND_HOST_READY,
    RNDZ_CCMD_SpMAX
} RNDZ_CCMD_SPECIES;

typedef  enum RNDZCRSTtypSPECIES {
    RNDZ_CRST_SpNONE = 0,
    RNDZ_CRST_SpSTART_RNDZ,
    RNDZ_CRST_SpGET_ENCRYPT_KEY,
    RNDZ_CRST_SpMAX
} RNDZ_CRST_SPECIES;

typedef  enum RNDZCRSPtypSPECIES {
    RNDZ_CRSP_SpNONE = 0,
    RNDZ_CRSP_SpRNDZ_ACCEPT,
    RNDZ_CRSP_SpSEND_ENCRYPT_KEY,
    RNDZ_CRSP_SpHOST_READY,
    RNDZ_CRSP_SpMAX
} RNDZ_CRSP_SPECIES;

#define RNDZ_CONNECT_MSG    "RNDZCONNECT"


#endif /* #if !defined(CRNDZAPP_H) */


